/*
$Header: /home/globdev/CVS/globus-packages/mds/openldap/ldapmodules/external.h,v 1.1.1.1 2002/01/10 02:10:09 jslee Exp $
$Log: external.h,v $
Revision 1.1.1.1  2002/01/10 02:10:09  jslee
importing globus-beta-branch to the main trunk

Revision 1.1  2001/09/19 20:37:52  meisu
1) upgrading 2.0.14 and some cleanup and bug fixes

Revision 1.1  2001/08/06 22:15:39  bletzing
New Package.  Doesn't Build.

Revision 1.1.1.1  2001/07/06 21:11:15  mei
1) splitting out back-ldif from the openldap 2.0.8-patched into a standalone
   directory that can generate 'dynamic modules' that can be used by the
   openldap's slapd (checked against 2.0.11 already)

Revision 1.2  2001/05/24 01:05:06  june
gridmap checking & timelimit debugging

Revision 1.1  2001/03/24 00:08:37  june
adding ldif backend

Revision 1.1  2001/03/22 03:01:25  june
add ldif backend

Revision 1.3  2000/09/13 02:11:50  june
resolve changes between 2.0 & 2.0.1

Revision 1.2  2000/09/12 22:41:39  june
Add ldif backend
*/

#ifndef _LDIF_EXTERNAL_H
#define _LDIF_EXTERNAL_H

LDAP_BEGIN_DECL

extern int	ldif_back_initialize LDAP_P(( BackendInfo *bi ));

extern int ldif_back_bind LDAP_P(( BackendDB *bd,
        Connection *conn, Operation *op,
        const char *dn, const char *ndn, int method,
        struct berval *cred, char** edn ));

extern int	ldif_back_search LDAP_P(( BackendDB *be,
	Connection *c, Operation *o,
	const char *base, const char *nbase,
	int scope, int deref, int slimit, int tlimit,
	Filter *f, const char *filterstr,
	char **attrs, int attrsonly));

extern int 	ldif_back_db_config LDAP_P((BackendDB *bd,
	const char *fname, int lineno, int argc, char **argv ));

extern int	ldif_back_modify LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op,
	const char *dn, const char *ndn,
	Modifications *ml ));

extern int	ldif_back_modrdn LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op,
	const char *dn, const char *ndn,
	const char *newrdn, int deleteoldrdn,
	const char *newSuperior ));

extern int	ldif_back_add LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op, Entry *e ));

extern int	ldif_back_delete LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op,
	const char *dn, const char *ndn ));

extern int	ldif_back_abandon LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op, int msgid ));

LDAP_END_DECL

#endif /* _LDIF_EXTERNAL_H */

