/* init.c - initialize giis backend */
/*
$Header: /home/globdev/CVS/globus-packages/mds/openldap/giis-ldapmodules/init.c,v 1.10 2003/02/05 09:11:10 jslee Exp $
$Log: init.c,v $
Revision 1.10  2003/02/05 09:11:10  jslee
fixing threads runout - bugzilla #644

Revision 1.8.6.1  2003/01/10 21:57:21  jslee
changing locking, adding double buffering, and changing cache data structure

Revision 1.8  2002/10/16 01:17:00  jslee
fixing file descriptor leaks

Revision 1.7  2002/08/14 22:40:27  benc
Merge MDS2.2 into trunk.

Revision 1.6.20.1  2002/08/07 03:56:02  benc
Merged (hopefully) all of the mds_2_2_branch work onto this new branch.

Compiles and runs on Linux.

Revision 1.6.2.3  2002/06/14 07:34:18  jslee
fixing debug message (REGISTERING)

Revision 1.6.2.2  2002/06/12 22:09:22  jslee
adding mutual authentication functions

Revision 1.6.2.1  2002/05/20 22:17:16  jslee
adding syslog messages to the giis backend

Revision 1.1.1.1.2.1  2002/03/29 02:20:37  jslee
fixing crashing bug and memory leaks on registration

Revision 1.1.1.1  2002/01/10 02:10:09  jslee
importing globus-beta-branch to the main trunk

Revision 1.3.4.25  2001/11/06 17:17:20  smartin
added code to check for the number of arguments and presence of asctime_r

Revision 1.3.4.24  2001/10/30 01:18:35  jslee
fixing concurrency problems

Revision 1.3.4.23  2001/10/26 21:19:17  jslee
adding missing return in form_trailer

Revision 1.3.4.22  2001/10/26 18:58:33  jslee
debugging deadlock

Revision 1.3.4.21  2001/10/26 02:36:40  jslee
fixing memory leaks

Revision 1.3.4.20  2001/10/25 18:27:35  jslee
fixing concurrency problems

Revision 1.3.4.19  2001/10/23 02:02:39  jslee
set default sizelimit to 0

Revision 1.3.4.18  2001/10/22 06:24:49  jslee
increasing default sizelimit to 500 and regttl to 1200

Revision 1.3.4.17  2001/10/22 04:39:49  jslee
increasing sizelimit to 300 sec

Revision 1.3.4.16  2001/10/19 08:54:42  jslee
debugging registration process for multiple layer of giis

Revision 1.3.4.15  2001/10/18 23:23:08  jslee
changing the format of generalized time

Revision 1.3.4.14  2001/10/18 22:54:13  jslee
modifying search_glist for adding suffix

Revision 1.3.4.13  2001/10/15 23:29:23  jslee
cleaning up unused ldap functions

Revision 1.3.4.12  2001/10/15 21:21:05  jslee
minor changes for validto function

Revision 1.3.4.11  2001/10/15 21:12:57  jslee
adding Mds-keepto function in dispatch_active_obj

Revision 1.3.4.10  2001/10/13 06:11:41  jslee
enabling multiple giis backends per slapd\nremoving all the global variables

Revision 1.3.4.9  2001/10/11 23:58:07  jslee
adding Mds-keepto in registration

Revision 1.3.4.8  2001/10/10 01:52:26  jslee
fixing intermediate nodes creation bugs

Revision 1.3.4.7  2001/10/07 00:03:40  jslee
debugging giis caching

Revision 1.3.4.6  2001/10/06 00:49:09  jslee
adding dn relabling function

Revision 1.3.4.5  2001/10/05 21:02:16  jslee
modification for edg

Revision 1.3.4.4  2001/09/30 09:58:57  jslee
dealing with funny behavior of openldap, which inserts CRspace after the 78th character of a string

Revision 1.3.4.3  2001/09/28 13:53:46  jslee
adjusting to restructured dn

Revision 1.3.4.2  2001/09/26 21:18:35  smartin
committing merge from main repository trunk to beta branch

*/


#include "portable.h"

#include <stdio.h>

#include <ac/socket.h>

#include <ac/signal.h>

#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <ctype.h>
#include <sys/socket.h>
#include <string.h>
#include <errno.h>

#include <strings.h>
#include <stdlib.h>

#define ENV_VAR_SIZE 1
#define SLAPD_GIIS_DYNAMIC 1
#define MAX_HOSTNAME 1024

char *apply_env_vars(char *);
char *str_realloc(char *, int, int *);

/*
void mysig(int);
*/

#include "slap.h"
#include "ldap_pvt.h"
#include "slapd_giis.h"

#ifdef SLAPD_GIIS_DYNAMIC

int libback_giis_LTX_init_module(int argc, char *argv[]) {
    BackendInfo bi;

    memset( &bi, '\0', sizeof(bi) );
    bi.bi_type = "giis";
    bi.bi_init = giis_back_initialize;

    backend_add(&bi);
    return 0;
}


#endif /* SLAPD_GIIS_DYNAMIC */


int
giis_back_initialize(
    BackendInfo	*bi
)
{
	bi->bi_open = 0;
	bi->bi_config = 0;
	bi->bi_close = 0;
	bi->bi_destroy = 0;

	bi->bi_db_init = 0;
	bi->bi_db_config = giis_back_db_config;
	bi->bi_db_open = 0;
	bi->bi_db_close = 0;
	bi->bi_db_destroy = 0;

	bi->bi_op_bind = giis_back_bind;
	bi->bi_op_unbind = 0;
	bi->bi_op_search = giis_back_search;
	bi->bi_op_compare = 0;
	bi->bi_op_modify = giis_back_modify;
	bi->bi_op_modrdn = giis_back_modrdn;
	bi->bi_op_add = giis_back_add;
	bi->bi_op_delete = giis_back_delete;
	bi->bi_op_abandon = giis_back_abandon;

	bi->bi_extended = 0;

	bi->bi_acl_group = 0;
	bi->bi_acl_attribute = 0;
	bi->bi_chk_referrals = 0;

	bi->bi_connection_init = 0;
	bi->bi_connection_destroy = 0;

/*
        signal(SIGPWR, mysig);
*/

	return 0;
}


/*****************************************************************
   this routine is commented out because there's no way to
   access be->be_private data structure in this routine

void 
mysig(int sig)
{
	extern char *giisconfigfile;
	extern char *giispolicyfile;

	if (giisconfigfile) {
		if (readconf(giisconfigfile) == -1)
			fprintf(stderr, "config file ($s) read error\n", giisconfigfile);
	}
	else {
		fprintf(stderr, "Can't read config file\n");
	}

	if (giispolicyfile) {
		if (read_policy_file(giispolicyfile) == -1)
			fprintf(stderr, "config file ($s) read error\n", giispolicyfile);
	}
	else {
		fprintf(stderr, "Can't read config file\n");
	}

	return;
}
*****************************************************************/


int 
readconf(GiisDT *gdt)
{

	FILE		*fptr;
	char		*obj;
	char		*filename;
	int		res, data_size = GIIS_DATA_SIZE;

	if ( gdt->giisconfigfile == NULL ) {
		fprintf( stderr, "giis config filename not found\n" );
		Debug( LDAP_DEBUG_ANY, "giis config file not found\n", 0, 0, 0 );
		return( -1 );
        }

	if ( (fptr = fopen( gdt->giisconfigfile, "r" )) == NULL ) {
		fprintf (stderr, "Can't open %s\n", gdt->giisconfigfile);
		Debug (LDAP_DEBUG_ANY, "Can't open %s\n", gdt->giisconfigfile, 0, 0 );
		return -1;
	}

	ldap_pvt_thread_mutex_lock( &gdt->glist_mutex );
	if (*gdt->glist) {
		clear_list(*gdt->glist, gdt->total_inx);
		gdt->total_inx = 0;
	}
	else {
		*gdt->glist = (ActiveObj **) calloc(data_size, sizeof(ActiveObj *));
		if (!*gdt->glist) {
			fprintf( stderr, "memory allocation failed\n" );
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			fclose (fptr);
			return( -1 );
		}
		gdt->total_inx = 0;
	}
	ldap_pvt_thread_mutex_unlock(&gdt->glist_mutex);

	for ( obj = getstrent(fptr); obj != NULL; obj = getstrent(fptr) ) {
		res = add_obj(gdt->glist, obj, &gdt->total_inx, &gdt->glist_mutex, gdt->giisgiven_sfx, gdt->local_port);
		if (res == -1) {
			if (obj) free(obj);
			fclose (fptr);
			return -1;
		}
		else if (res == 0){
			if (obj) free(obj);
			continue;
		}
		if (obj) free(obj);
	}

	fclose (fptr);

	return( 0 );
}


int 
read_policy_file(GiisDT *gdt)
{

	FILE		*fptr;
	char		*obj;
	int		inx, res, data_size = GIIS_DATA_SIZE;

	if ( gdt->giispolicyfile == NULL ) {
		fprintf( stderr, "giis policy file not found\n" );
		Debug( LDAP_DEBUG_ANY, "giis policy file not found\n", 0, 0, 0 );
		return( -1 );
        }

	if ( (fptr = fopen( gdt->giispolicyfile, "r" )) == NULL ) {
		fprintf (stderr, "Can't open %s\n", gdt->giispolicyfile);
		Debug (LDAP_DEBUG_ANY, "Can't open %s\n", gdt->giispolicyfile, 0, 0 );
		return -1;
	}

	ldap_pvt_thread_mutex_lock( &(gdt->rpolicy_mutex) );
	if (*gdt->rpolicy) {
		for (inx=0; inx<gdt->total_rpolicy; inx++)
			if ((*gdt->rpolicy)[inx]) free((*gdt->rpolicy)[inx]);
		gdt->total_rpolicy = 0;
	}
	else {
		*gdt->rpolicy = (char **) calloc(data_size, sizeof(char *));
		if (!*gdt->rpolicy) {
			fprintf( stderr, "memory allocation failed\n" );
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			fclose (fptr);
			return( -1 );
		}
		gdt->total_rpolicy = 0;
	}
	ldap_pvt_thread_mutex_unlock(&(gdt->rpolicy_mutex));

	for ( obj = getstrent(fptr); obj != NULL; obj = getstrent(fptr) ) {
		res = add_policy(gdt->rpolicy, &gdt->total_rpolicy, &gdt->rpolicy_mutex, obj);
		if (res == -1) {
			if (obj) free(obj);
			fclose (fptr);
			return -1;
		}
		else if (res == 0){
			if (obj) free(obj);
			continue;
		}
		if (obj) free(obj);
	}

	fclose (fptr);

	return( 0 );
}


char *
getstrent(FILE *rfp)
{
	char *line, *res = NULL, *obj = NULL, buffer[BUFF_SIZE];
	int len, cur = 0, max = BUFF_SIZE;

	obj = (char *) calloc( max, sizeof(char) );
	(void) memset(obj, 0, max);

	while ( (res = fgets(buffer, sizeof(buffer), rfp)) != NULL) {

		line = strip_comments(buffer);
		if (!line)
			return NULL;

		len = strlen( line );
		if (len <= 0) {
			if (line) free(line);
			continue;
		}

		if (line[0] != '\n') {
			while ( cur + len + 1 > max ) { 
				max += BUFF_SIZE; 
				obj = (char *) realloc( obj, max );
			}
			strcpy( obj + cur, line );
			cur += len;
			buffer[0] = '\0';
			if (line) free(line);
		}
		else {
			buffer[0] = '\0';
			if (line) free(line);
			if (obj[0])
				return obj;
			else
				continue;
		}
	}
	buffer[0] = '\0';

	if (obj[0]) return obj;
	else {
		if (obj) free(obj);
		return NULL;
	}
}


char *
getdatastr(FILE *rfp)
{
	char *res = NULL, *obj = NULL, buffer[BUFF_SIZE];
	int len, cur = 0, max = BUFF_SIZE;

	obj = (char *) calloc( max, sizeof(char) );
	if (!obj) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return NULL;
	}
	(void) memset(obj, 0, max);

	while ( (res = fgets(buffer, sizeof(buffer), rfp)) != NULL) {

		len = strlen( buffer );
		while ( cur + len + 1 > max ) { 
			max += BUFF_SIZE; 
			obj = (char *) realloc( obj, max );
			if (!obj) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				return NULL;
			}
		}
		strcpy( obj + cur, buffer );
		cur += len;

		buffer[0] = '\0';
	}
	buffer[0] = '\0';

	if (obj[0])
		return obj;
	else {
		free(obj);
		return NULL;
	}
}


char *
getpolicyline(FILE *rfp)
{
	char *res = NULL, *obj = NULL, buffer[BUFF_SIZE];
	int len, cur = 0, max = BUFF_SIZE;

	obj = (char *) calloc( max, sizeof(char) );
	if (!obj) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return NULL;
	}
	(void) memset(obj, 0, max);

	while ( (res = fgets(buffer, sizeof(buffer), rfp)) != NULL) {

		len = strlen( buffer );
		while ( cur + len + 1 > max ) { 
			max += BUFF_SIZE; 
			obj = (char *) realloc( obj, max );
			if (!obj) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				return NULL;
			}
		}
		strcpy( obj + cur, buffer );
		cur += len;

		buffer[0] = '\0';
	}
	buffer[0] = '\0';

	if (obj[0])
		return obj;
	else {
		free(obj);
		return NULL;
	}
}


int current_time()
{
	return (int) time(NULL);
}


char *get_attribute(char *str, char *pattern, int *index)
{
	int	no, inx, length;
	char	*tmpstr, *resstr, *teststr, *result;

	inx = 0;

	if (!str || !pattern) {
/*
		fprintf(stderr, "NULL String\n");
*/
		return NULL;
	}

	if (inx >= strlen(str))
		return NULL;

	if (index)
		teststr = str + *index;
	else
		teststr = str;

	if ( (resstr = strstr(teststr, pattern)) == NULL) {
/*
		fprintf(stderr, "%s not found\n", pattern);
*/
		return NULL;
	}

	/* deal with non-blank chars */
	tmpstr = resstr;
	while(tmpstr > teststr) {
		if (*--tmpstr == '\n')
			break;
		if (*tmpstr != ' ' && *tmpstr != '\t') {

			teststr = resstr + strlen(pattern);

			if ( (resstr = strstr(teststr, pattern)) == NULL) {
/*
				fprintf(stderr, "%s not found\n", pattern);
*/
				return NULL;
			}
			tmpstr = resstr;
		}
	}

	length = strlen(resstr);
	if (length <= 1) {
/*
		fprintf(stderr, "value of %s not found\n", pattern);
*/
		return NULL;
	}

	if ( (result = (char *) calloc(length, sizeof(char))) == NULL) {
		fprintf(stderr, "memory allocation error\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return NULL;
	}

	while(inx < length && resstr[inx] != ':') {
		inx++;
	}
	inx++;

	while(inx < length && resstr[inx] == ' ') {
		inx++;
	}

	if (inx >= length) {
		if (result) free(result);
/*
		fprintf(stderr, "value of %s not found\n", pattern);
*/
		return NULL;
	}

	no = 0;
	while(inx < length) {
		if (resstr[inx] != '\n') {
			result[no++] = resstr[inx++];
		}
		else {
			/* deal with the funny bug of openldap, which is inserting "\n "
			   when the length of the string exceeds 80 */
			if (inx + 1 < length && resstr[inx+1] == ' ') {
				inx += 2;
				continue;
			}
			result[no] = 0;

			/* get rid of spaces at the end of strings */
			while (no > 0) {
				if(result[no-1] == ' ' || result[no-1] == '\t') {
					result[no-1] = 0;
					no--;
				}
				else
					break;
			}
			if (index) *index = resstr - str + inx;
			return result;
		}
	}

	if (result) free(result);
/*
	fprintf(stderr, "invalid value of %s\n", pattern);
*/
	return NULL;
}


int print_arg(char *arg)
{
FILE *wfp;
char file[300], *loc = getenv("GLOBUS_LOCATION");

	if (!loc) return 0;
	sprintf(file, "%s/var/printdata.txt", loc);
        wfp = fopen(file, "a");
	if (wfp == NULL) exit(1);

        fprintf(wfp, "%s", arg);
        fclose (wfp);
        return 0;
}

int print_int_arg(int arg)
{
FILE *wfp;
char file[300], *loc = getenv("GLOBUS_LOCATION");

	if (!loc) return 0;
	sprintf(file, "%s/var/printdata.txt", loc);
        wfp = fopen(file, "a");
	if (wfp == NULL) exit(1);

        fprintf(wfp, "%d", arg);
        fclose (wfp);
        return 0;
}


int print_glist(ActiveObj **glist, int total_inx)
{
ActiveObj *current;
int inx=0;
FILE *wfp;

	int no;
	static char	*objtypes[] = {"EXEC", "DYNAMIC", "STATIC", "INVALID"};

	if (!glist) return 0;

	while(inx < total_inx) {
		printf("*************** Entry %d ****************\n", inx+1);
		if (glist[inx] == NULL) {
			printf("glist[%d] purged\n", inx);
			inx++;
			continue;
		}
		printf("dn: %s\n", (glist[inx])->dn);

		no = 0;
		if ((glist[inx])->objectclass)
			while((glist[inx])->objectclass[no]) {
				printf("objectclass[%d]: %s\n", no, (glist[inx])->objectclass[no]);
				no++;
			}

		if ((glist[inx])->hn)
			printf("hn: %s\n", (glist[inx])->hn);
		if ((glist[inx])->port)
			printf("port: %d\n", (glist[inx])->port);
		if ((glist[inx])->type)
			printf("type: %s\n", objtypes[(glist[inx])->type]);
		if ((glist[inx])->path) 
			printf("path: %s\n", (glist[inx])->path);
		if ((glist[inx])->base) 
			printf("base: %s\n", (glist[inx])->base);
		no = 0;
		if ((glist[inx])->args)
			while((glist[inx])->args[no]) {
				printf("args[%d]: %s\n", no, (glist[inx])->args[no]);
				no++;
			}

		if ((glist[inx])->cachetime >= 0)
			printf("cachetime: %d\n", (glist[inx])->cachetime);
		if ((glist[inx])->timelimit >= 0)
			printf("timelimit: %d\n", (glist[inx])->timelimit);
		if ((glist[inx])->sizelimit >= 0)
			printf("sizelimit: %d\n", (glist[inx])->sizelimit);
		if ((glist[inx])->tlimit >= 0)
			printf("tlimit: %d\n", (glist[inx])->tlimit);
		if ((glist[inx])->slimit >= 0)
			printf("slimit: %d\n", (glist[inx])->slimit);
		if ((glist[inx])->stoptime >= 0)
			printf("stoptime: %d\n", (glist[inx])->stoptime);
		if ((glist[inx])->lastmodified)
			printf("lastmodified: %d\n", (glist[inx])->lastmodified);
		if ((glist[inx])->activeobject >= 0)
			printf("activeobject: %d\n", (glist[inx])->activeobject);
		if ((glist[inx])->activesearch >= 0)
			printf("activesearch: %d\n", (glist[inx])->activesearch);
		if ((glist[inx])->registerttl >= 0)
			printf("registerttl: %d\n", (glist[inx])->registerttl);
		if ((glist[inx])->validto)
			printf("validto: %s\n", (glist[inx])->validto);
		if ((glist[inx])->keepto)
			printf("keepto: %s\n", (glist[inx])->keepto);
		if ((glist[inx])->suffix)
			printf("suffix: %s\n", (glist[inx])->suffix);
		if ((glist[inx])->lastregistered >= 0)
			printf("lastregistered: %d\n", (glist[inx])->lastregistered);
		inx++;
	}
	printf("*****************************************\n");
	return 0;
}


int clear_list(ActiveObj **list, int total_inx)
{
	int inx=0;

	if (!list) return 0;

	while(inx < total_inx) {
		ldap_pvt_thread_mutex_lock(&(list[inx])->active_obj_mutex);
		clear_activeobj(list[inx]);
		ldap_pvt_thread_mutex_unlock(&(list[inx])->active_obj_mutex);
/*
		list[inx] = NULL;
*/
		inx++;
	}
	return 0;
}


int clear_activeobj(ActiveObj *actobj)
{

	int no, i;
	DataObj *cdataobj, *ndataobj;

	if (!actobj) {
		return 0;
	}
/*
	if (actobj->purged) {
		return 0;
	}
*/

	actobj->purged = 1;

	if (actobj->dn) {
		free(actobj->dn); 
		actobj->dn = NULL;
	}
	else
		return 0;

	if (actobj->hn) free(actobj->hn);

	no = 0;
	if (actobj->objectclass)
		while(actobj->objectclass[no]) {
			free (actobj->objectclass[no]);
			no++;
		}
	if (actobj->objectclass) free(actobj->objectclass);

	if (actobj->base) free(actobj->base);
	if (actobj->path) free(actobj->path);
	if (actobj->suffix) free(actobj->suffix);
	if (actobj->keepto) free(actobj->keepto);
	if (actobj->validto) free(actobj->validto);

	no = 0;
	if (actobj->args)
		while(actobj->args[no]) {
			free (actobj->args[no]);
			no++;
		}
	if (actobj->args) free(actobj->args);

	if (actobj->dataobj) {
		for (i=0; i<actobj->mod; i++) {
			if(actobj->dataobj[i]) {
				cdataobj = actobj->dataobj[i];
				ndataobj = cdataobj;
				while(ndataobj) {
					ndataobj = cdataobj->next;
					entry_free(cdataobj->e);
					free(cdataobj);
					cdataobj = ndataobj;
				}
			}
		}
	}

	if (actobj->ld) free(actobj->ld);

/*
	ldap_pvt_thread_mutex_destroy(&actobj->active_obj_mutex);
	if (actobj) free(actobj);
*/

	return 0;
}


int unset_trailer(TrailerObj **gtrailer, TrailerObj **ltrailer)
{
	if (*gtrailer)
		clear_trailer(*gtrailer);
	*gtrailer = NULL;
	*ltrailer = NULL;
}


int clear_trailer(TrailerObj *list)
{
	TrailerObj *current, *tmp;

	current = list;

	while(current) {
		tmp = current->next;
		if (current->dn) free(current->dn);
		if (current->objectclass) free(current->objectclass);
		if (current->objectname) free(current->objectname);
		if (current->lastupdate) free(current->lastupdate);
		if (current->data) free(current->data);
		current->next = NULL;
		current = tmp;
	}
	return 0;
}


char **get_args(char *path, char *base, char *args)
{

	int inx, leng, cnt, arg_no = MAX_ARGS_NO, lpath, lbase; 
	int size, no;
	char **argv, *str, *res, tmpc, *cmd;

	if (!base) return NULL;

	if ((argv = (char **) calloc(arg_no, sizeof(char *))) == NULL) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return NULL;
	}

	if (!path) {
		if ((cmd = (char *) strdup(base)) == NULL) {
			fprintf(stderr, "memory allocation failed\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			free(argv);
			return NULL;
		}
	}
	else {
		lpath = strlen(path);
		lbase = strlen(base);

		if ( path[lpath-1] == '/' && base[0] == '/') {
			if ((cmd = (char *) calloc(lpath+lbase+2, sizeof(char))) == NULL) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				free(argv);
				return NULL;
			}
			strcpy(cmd, path);
			strcat(cmd, ".");	
			strcat(cmd, base);
		}
		else if ( path[lpath-1] == '/' || base[0] == '/') {
			if ((cmd = (char *) calloc(lpath+lbase+1, sizeof(char))) == NULL) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				free(argv);
				return NULL;
			}
			strcpy(cmd, path);
			strcat(cmd, base);
		}
		else {
			if ((cmd = (char *) calloc(lpath+lbase+2, sizeof(char))) == NULL) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				free(argv);
				return NULL;
			}
			strcpy(cmd, path);
			strcat(cmd, "/");	
			strcat(cmd, base);
		}
	}

	argv[0] = cmd;

	if (!args) {
		argv[1] = NULL;
		return argv;
	}

	leng = strlen(args);

	inx = 0;
	while(inx < leng) 
		if (args[inx] == ' ') 
			inx++;
		else
			break;

	if (inx >= leng) { 
		argv[1] = NULL;
		return argv;
	}

	cnt = 1;
	while (inx < leng) {
		if ( (str = strchr(args + inx, ' ')) != NULL) {
			size = str - args - inx + 1;
			if ((res = (char *) calloc(size, sizeof(char))) == NULL) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				(void) free_strlist(argv, cnt-1);
				free(argv);
				str[0] = tmpc;
				return NULL;
			}
			for (no = 0; no < size-1; no++)
				res[no] = args[inx + no];
			res[no] = 0;

			if (strlen(res)) {
				if (cnt >= arg_no) {
					arg_no += MAX_ARGS_NO;
					if ((argv = (char **) realloc(argv, arg_no * sizeof(char *))) == NULL) {
						fprintf(stderr, "memory allocation failed\n");
						Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
						(void) free_strlist(argv, cnt);
						free(argv);
						free(res);
						return NULL;
					}
				}
				argv[cnt++] = res;
			}
			else
				if (res) free(res);

			inx = (int) str - (int) args + 1;
		}
		else
			break;
	}

	if ((res = (char *) strdup(args+inx)) == NULL) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		(void) free_strlist(argv, cnt);
		free(argv);
		return NULL;
	}

	if (strlen(res)) {
		if (cnt >= arg_no) {
			arg_no += 2;
			if ((argv = (char **) realloc(argv, arg_no * sizeof(char*))) == NULL) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				(void) free_strlist(argv, cnt);
				free(argv);
				return NULL;
			}
		}
		argv[cnt++] = res;
	}
	if (cnt >= arg_no) {
		arg_no += 1;
		if ((argv = (char **) realloc(argv, arg_no * sizeof(char *))) == NULL) {
			fprintf(stderr, "memory allocation failed\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			(void) free_strlist(argv, cnt);
			free(argv);
			return NULL;
		}
	}
	argv[cnt] = NULL;

	return argv;
}


int free_strlist(char **argv, int no)
{

	int inx = 0;

	while(inx < no) {
		if (argv[inx]) free(argv[inx]);
		inx++;
	}

	return 0;
}


char * strip_comments(char *obj)
{

	int i, no, size, cnt, add_nl;
	char *res, *spinx, *nlinx, *tmp;

	if (!obj) return NULL;

	spinx = strchr(obj, '#');
	if (!spinx) {
		if ((res = (char *) strdup(obj)) == NULL) {
			fprintf(stderr, "memory allocation failure\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			return NULL;
		}
		return res;
	}

	size = strlen(obj);
	if ( (res = (char *) calloc(size+1, sizeof(char))) == NULL ) {
		fprintf(stderr, "memory allocation failure\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return NULL;
	}

	tmp = spinx - 1;
	while (tmp >= obj && (*tmp == ' ' || *tmp == '\t'))
		tmp--;
	if (tmp >= obj && *tmp != '\n')
		add_nl = 1;
	else
		add_nl = 0;

	no = 0;
	cnt = 0;

	while ( spinx ) {
		for (i = no; i < spinx - obj; i++)
			res[cnt++] = obj[i];
		if (add_nl) {
			res[cnt++] = '\n';
		}

		if ((nlinx = strchr(spinx, '\n')) == NULL) {
			spinx = NULL;
			no = size - 1;
			continue;
		}

		no = nlinx - obj + 1;
		spinx = strchr(nlinx, '#');

		if (spinx) {
			tmp = spinx - 1;
			while (tmp >= obj && (*tmp == ' ' || *tmp == '\t'))
				tmp--;
			if (tmp >= obj && *tmp != '\n')
				add_nl = 1;
			else
				add_nl = 0;
		}
	}

	for (i = no; i < size; i++)
		res[cnt++] = obj[i];
	res[cnt] = 0;

	return res;
}


char *
str_realloc(char *result, int no, int *mf)
{

	while (no >= ENV_VAR_SIZE*(*mf)) {
		*mf += 1;
		result = (char *) realloc(result, ENV_VAR_SIZE*(*mf));
		if (!result) {
			fprintf(stderr, "memory allocation error\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			return NULL;
		}
	}
	return result;
}


char *
apply_env_vars(char *tstr)
{
	int no, size, i, j, mf_res, mf_str;
	int dflag = 0, oflag = 0;
	int start, end;
	char *str, *result, *environ;
	struct stat buf;

	if (!tstr) {
/*
		fprintf(stderr, "Null String\n");
*/
		return NULL;
	}
	size = strlen(tstr);

	result = (char *) calloc(ENV_VAR_SIZE, sizeof(char));
	if(!result) {
		fprintf(stderr, "memory allocation error\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return NULL;
	}

	str = (char *) calloc(ENV_VAR_SIZE, sizeof(char));
	if(!str) {
		fprintf(stderr, "memory allocation error\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		if (result) free(result);
		return NULL;
	}

	mf_res = 1;
	mf_str = 1;
	no = 0;
	for (i=0; i<size; i++) {
		switch (tstr[i]) {
			case '$':
				dflag = 1;
				break;
			case '{':
				if (dflag && i < size-1) {
					oflag = 1;
					start = i+1;
				}
				else {
					if ((result = str_realloc(result, no, &mf_res)) != NULL) {
						result[no++] = tstr[i];
					}
					else {
						if (str) free(str);
						return NULL;
					}
				}
				dflag = 0;
				break;
			case '}':
				if (oflag) {
					end = i;
					for (j=0; j<end-start; j++) {
						if ((str = str_realloc(str, j, &mf_str)) != NULL) {
							str[j] = tstr[start+j];
						}
						else {
							if (result) free(result);
							return NULL;
						}
					}
					if (j>0) {
						if ((str = str_realloc(str, j, &mf_str)) != NULL) {
							str[j] = 0;
						}
						else {
							if (result) free(result);
							return NULL;
						}
					}
					else {
						if (str) free(str);
						if (result) free(result);
						return NULL;
					}

					if((environ = getenv(str)) != NULL) {
						for (j=0; j<strlen(environ); j++) {
							if ((result = str_realloc(result, no, &mf_res)) != NULL) {
								result[no++] = environ[j];
							}
							else {
								if (str) free(str);
								return NULL;
							}
						}
					}
					else {
						fprintf(stderr, "environment \"%s\" not set\n", str);
						Debug(LDAP_DEBUG_ANY, "environment \"%s\" not set\n", str, 0, 0 );
						if (str) free(str);
						if (result) free(result);
						return NULL;
					}
					dflag = 0;
					oflag = 0;
				}
				else {
					if ((result = str_realloc(result, no, &mf_res)) != NULL) {
						result[no++] = tstr[i];
					}
					else {
						if (str) free(str);
						return NULL;
					}
				}
				dflag = 0;
				break;
			default:
				if(!oflag) {
					if ((result = str_realloc(result, no, &mf_res)) != NULL) {
						result[no++] = tstr[i];
					}
					else {
						if (str) free(str);
						return NULL;
					}
				}
				dflag = 0;
				break;
		}
	}

	if (oflag && start > 1) {
		for(j=start-2; j<size; j++) {
			if ((result = str_realloc(result, no, &mf_res)) != NULL) {
				result[no++] = tstr[j];
			}
			else {
				if (str) free(str);
				return NULL;
			}
		}
	}

	if ((result = str_realloc(result, no, &mf_res)) != NULL) {
		result[no] = 0;
	}
	else {
		if (str) free(str);
		return NULL;
	}

	if (str) free(str);

	return result;
}



int
add_obj (ActiveObj ***glist, char *obj, int *total_inx, ldap_pvt_thread_mutex_t *glist_mutex, char *sfx, int local_port)
{

	int		objclass_no, activeobj, activesch, obj_no, objclass_inx, regobj;
	int		type, cachetime, timelimit, sizelimit, port, regttl;
	int		data_size = GIIS_DATA_SIZE, obj_size, sbind_m;
	int		no;

	char 		*dn, *tdn, *tmp, *typestr, *base, *path, *tpath;
	char		*args, *targs, *hn, *thn, *portstr, *regttlstr, *keepto;
	char		*cachetimestr, *timelimitstr, *sizelimitstr, *validto;
	char		*suffix, *tsuffix, *tsbind_m;
	char		**objclass, *cmp_obj;
	static char	*objtypes[] = {"EXEC", "DYNAMIC", "STATIC", "INVALID"};

	tdn = get_attribute(obj, "dn:", NULL);
	if (!tdn) {
		fprintf(stderr, "dn not found\n");
		Debug( LDAP_DEBUG_ANY, "dn not found\n", 0, 0, 0 );
		return 0;
	}
	dn = apply_env_vars(tdn);
	if (tdn) free(tdn);

	obj_size = strlen(obj);
	cmp_obj = (char *) calloc(obj_size+1, sizeof(char));
	if (!cmp_obj) {
		fprintf( stderr, "memory allocation failed\n" );
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(dn);
		return -1;
	}
	for (no=0; no<obj_size; no++)
		cmp_obj[no] = tolower(obj[no]);
	cmp_obj[no] = 0;

	objclass_no = MAX_OBJCLASS_NO;
	if ((objclass = (char **) calloc(objclass_no, sizeof(char *))) == NULL) {
		fprintf( stderr, "memory allocation failed\n" );
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(dn);
		free(cmp_obj);
		return -1;
	}

	activeobj = 0;
	activesch = 0;
	regobj = 0;
	obj_no = 0;
	objclass_inx = 0;

	tmp = get_attribute(cmp_obj, "objectclass:", &objclass_inx);
	while( tmp ) {
		if (obj_no >= objclass_no) {
			objclass_no += MAX_OBJCLASS_NO;
			if ((objclass = (char **) realloc(objclass, objclass_no * sizeof(char *))) == NULL) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				free(dn);
				free(cmp_obj);
				(void) free_strlist(objclass, obj_no);
				free(objclass);
				return -1;
			}
		}
		objclass[obj_no++] = tmp;
		if (!strcasecmp(tmp, "GlobusActiveObject"))
			activeobj = 1;
		if (!strcasecmp(tmp, "GlobusActiveSearch"))
			activesch = 1;
		if (!strcasecmp(tmp, "MdsServiceLdap"))
			regobj = 1;
		tmp = get_attribute(cmp_obj, "objectclass:", &objclass_inx);
	}

	if (obj_no >= objclass_no) {
		objclass_no += 1;
		if ((objclass = (char **) realloc(objclass, objclass_no * sizeof(char *))) == NULL) {
			fprintf(stderr, "memory allocation failed\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			free(dn);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			return -1;
		}
	}
	objclass[obj_no] = NULL;

	if (!activeobj) {
		thn = get_attribute(obj, "Mds-Service-hn:", NULL);
		if (!thn) {
			fprintf(stderr, "Mds-Service-hn not found\n");
			Debug( LDAP_DEBUG_ANY, "Mds-Service-hn not found\n", 0, 0, 0 );
			free(dn);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			return 0;
		}
		hn = apply_env_vars(thn);
		if (thn) free(thn);

		portstr = get_attribute(obj, "Mds-Service-port:", NULL);
		if (portstr) {
			errno = 0;
			port = atoi(portstr);
			if (errno) {
				fprintf(stderr, "Invalid port: %s\n", portstr);
				Debug( LDAP_DEBUG_ANY, "Invalid port: %s\n", portstr, 0, 0 );
				free(dn);
				free(hn);
				free(cmp_obj);
				(void) free_strlist(objclass, obj_no);
				free(objclass);
				if(portstr) free(portstr);
				return 0;
			}
			free(portstr);
		}
		else {
			fprintf(stderr, "port not found\n");
			Debug( LDAP_DEBUG_ANY, "port not found\n", 0, 0, 0 );
			free(dn);
			free(hn);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			return 0;
		}

		tsuffix = get_attribute(obj, "Mds-Service-Ldap-suffix:", NULL);
		if (!tsuffix) {
			fprintf(stderr, "Mds-Service-Ldap-suffix not found\n");
			Debug( LDAP_DEBUG_ANY, "Mds-Service-Ldap-suffix not found\n", 0, 0, 0 );
			free(dn);
			free(hn);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			return 0;
		}
		suffix = apply_env_vars(tsuffix);
		if (tsuffix) free(tsuffix);

		/* relable dn with suffix value */
		if (dn) free(dn);
		if ((dn = relable_dn(suffix, sfx)) == NULL) {
			fprintf(stderr, "dn relable failed\n");
			Debug( LDAP_DEBUG_ANY, "dn relable failed\n", 0, 0, 0 );
			free(hn);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			return 0;
		}

		keepto = get_attribute(obj, "Mds-keepto:", NULL);
		validto = get_attribute(obj, "Mds-validto:", NULL);

		ldap_pvt_thread_mutex_lock(glist_mutex);
		if (search_glist(*glist, hn, port, suffix, validto, keepto, *total_inx) == 1) {
/*
			(void) purge_old_entry(*glist, *total_inx);
*/
			Debug( LDAP_DEBUG_ANY, "REGISTERING %s:%d (%s)\n", hn, port, suffix );
			free(dn);
			free(hn);
			free(suffix);
			if(keepto) free(keepto);
			if(validto) free(validto);
			if(cmp_obj) free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			ldap_pvt_thread_mutex_unlock(glist_mutex);
			return 1;
		}
		ldap_pvt_thread_mutex_unlock(glist_mutex);
	}
	else {
		hn = NULL;
		port = 0;
	}

	typestr = get_attribute(obj, "Mds-Service-type:", NULL);
	if (!typestr) {
		fprintf(stderr, "object type not found\n");
		Debug( LDAP_DEBUG_ANY, "object type not found\n", 0, 0, 0 );
		free(dn);
		if (hn) free(hn);
		if (suffix) free(suffix);
		if(keepto) free(keepto);
		if(validto) free(validto);
		free(cmp_obj);
		(void) free_strlist(objclass, obj_no);
		free(objclass);
		return 0;
	}
	if ( !strcasecmp(objtypes[EXEC], typestr )) 
		type = EXEC;
	else if ( !strcasecmp(objtypes[DYNAMIC], typestr ))
		type = DYNAMIC;
	else if ( !strcasecmp(objtypes[STATIC], typestr ))
		type = STATIC;
/* need to be changed after the beta release */
	else if ( !strcasecmp("ldap", typestr ))
		type = DYNAMIC;
	else {
		fprintf(stderr, "Invalid object type: %s\n", typestr);
		Debug(LDAP_DEBUG_ANY, "Invalid object type: %s\n", typestr, 0,
0 );
		free(dn);
		if (hn) free(hn);
		if (suffix) free(suffix);
		if(keepto) free(keepto);
		if(validto) free(validto);
		free(cmp_obj);
		(void) free_strlist(objclass, obj_no);
		free(objclass);
		free(typestr);
		return 0;
	}
	free (typestr);

	base = get_attribute(obj, "base:", NULL);
	if (!base && activeobj && type == EXEC) {
		fprintf(stderr, "base not found\n");
		Debug( LDAP_DEBUG_ANY, "base not found\n", 0, 0, 0 );
		free(dn);
		if (hn) free(hn);
		if (suffix) free(suffix);
		if(keepto) free(keepto);
		if(validto) free(validto);
		free(cmp_obj);
		(void) free_strlist(objclass, obj_no);
		free(objclass);
		return 0;
	}

	tpath = get_attribute(obj, "path:", NULL);
	path = apply_env_vars(tpath);
	if (tpath) free(tpath);

	targs = get_attribute(obj, "args:", NULL);
	args = apply_env_vars(targs);
	if (targs) free(targs);

	cachetimestr = get_attribute(obj, "Mds-Service-Ldap-cachettl:", NULL);
	timelimitstr = get_attribute(obj, "Mds-Service-Ldap-timeout:", NULL);
	sizelimitstr = get_attribute(obj, "Mds-Service-Ldap-sizelimit:", NULL);
	regttlstr = get_attribute(obj, "Mds-Service-Ldap-ttl:", NULL);

	if (cachetimestr) {
		errno = 0;
		cachetime = atoi(cachetimestr);
		if (errno) {
			fprintf(stderr, "Invalid cachetime: %s\n", cachetimestr);
			Debug(LDAP_DEBUG_ANY, "Invalid cachetime: %s\n", cachetimestr, 0, 0 );
			free(dn);
			if (hn) free(hn);
			if (suffix) free(suffix);
			if(keepto) free(keepto);
			if(validto) free(validto);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			if(base) free(base);
			if(path) free(path);
			if(args) free(args);
			if(cachetimestr) free(cachetimestr);
			if(timelimitstr) free(timelimitstr);
			if(sizelimitstr) free(sizelimitstr);
			if(regttlstr) free(regttlstr);
			return 0;
		}
		free(cachetimestr);
	}
	else if (!activeobj && !activesch && !regobj)
		cachetime = 0;
	else {
		fprintf(stderr, "cachetime not found\n");
		Debug( LDAP_DEBUG_ANY, "cachetime not found\n", 0, 0, 0 );
		free(dn);
		if (hn) free(hn);
		if (suffix) free(suffix);
		if(keepto) free(keepto);
		if(validto) free(validto);
		free(cmp_obj);
		(void) free_strlist(objclass, obj_no);
		free(objclass);
		if(base) free(base);
		if(path) free(path);
		if(args) free(args);
		if(timelimitstr) free(timelimitstr);
		if(sizelimitstr) free(sizelimitstr);
		if(regttlstr) free(regttlstr);
		return 0;
	}

	if (timelimitstr) {
		errno = 0;
		timelimit = atoi(timelimitstr);
		if (errno) {
			fprintf(stderr, "Invalid timelimit: %s\n", timelimitstr);
			Debug(LDAP_DEBUG_ANY, "Invalid timelimit: %s\n", timelimitstr, 0, 0 );
			free(dn);
			if (hn) free(hn);
			if (suffix) free(suffix);
			if(keepto) free(keepto);
			if(validto) free(validto);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			if(base) free(base);
			if(path) free(path);
			if(args) free(args);
			if(timelimitstr) free(timelimitstr);
			if(sizelimitstr) free(sizelimitstr);
			if(regttlstr) free(regttlstr);
			return 0;
		}
		free(timelimitstr);
	}
	else
		timelimit = 30;

	if (sizelimitstr) {
		errno = 0;
		sizelimit = atoi(sizelimitstr);
		if (errno) {
			fprintf(stderr, "Invalid sizelimit: %s\n", sizelimitstr);
			Debug(LDAP_DEBUG_ANY, "Invalid sizelimit: %s\n", sizelimitstr, 0, 0 );
			free(dn);
			if (hn) free(hn);
			if (suffix) free(suffix);
			if(keepto) free(keepto);
			if(validto) free(validto);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			if(base) free(base);
			if(path) free(path);
			if(args) free(args);
			free (sizelimitstr);
			if(regttlstr) free(regttlstr);
			return 0;
		}
		free(sizelimitstr);
	}
	else
		sizelimit = 0;

	if (regttlstr) {
		errno = 0;
		regttl = atoi(regttlstr);
		if (errno) {
			fprintf(stderr, "Invalid ttl: %s\n", regttlstr);
			Debug(LDAP_DEBUG_ANY, "Invalid ttl: %s\n", regttlstr, 0, 0 );
			free(dn);
			if (hn) free(hn);
			if (suffix) free(suffix);
			if(keepto) free(keepto);
			if(validto) free(validto);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			if(base) free(base);
			if(path) free(path);
			if(args) free(args);
			free (regttlstr);
			return 0;
		}
		free(regttlstr);
	}
	else
		/* default register ttl */
		regttl = 1200;

	tsbind_m = get_attribute(obj, "Mds-Bind-Method-servers:", NULL);
	if (tsbind_m) {
		errno = 0;
		if ( !strcasecmp(tsbind_m, "AUTHC-ONLY") )
			sbind_m = AUTHC_ONLY; 
		else if ( !strcasecmp(tsbind_m, "AUTHC-FIRST") )
			sbind_m = AUTHC_FIRST; 
		else
			sbind_m = ANONYM_ONLY; 

		free(tsbind_m);
	}
	else
		/* default server-to-server binding method */
		sbind_m = ANONYM_ONLY;

	ldap_pvt_thread_mutex_lock( glist_mutex );
	if ( *total_inx && !(*total_inx % data_size) ) {
		data_size = *total_inx + GIIS_DATA_SIZE;
		*glist = (ActiveObj **) realloc(*glist, data_size * sizeof(ActiveObj *));
		if (!*glist) {
			fprintf( stderr, "memory allocation failed\n" );
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			free(dn);
			if (hn) free(hn);
			if (suffix) free(suffix);
			if(keepto) free(keepto);
			if(validto) free(validto);
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			free(objclass);
			if(base) free(base);
			if(path) free(path);
			if(args) free(args);
			if(keepto) free(keepto);
			if(validto) free(validto);
			ldap_pvt_thread_mutex_unlock(glist_mutex);
			return -1;
		}
	}

	(*glist)[*total_inx] = (ActiveObj *) calloc( 1, sizeof(ActiveObj));
	if (!(*glist)[*total_inx]) {
		fprintf( stderr, "memory allocation failed\n" );
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(dn);
		if (hn) free(hn);
		if (suffix) free(suffix);
		if(keepto) free(keepto);
		if(validto) free(validto);
		free(cmp_obj);
		(void) free_strlist(objclass, obj_no);
		free(objclass);
		if(base) free(base);
		if(path) free(path);
		if(args) free(args);
		if(keepto) free(keepto);
		if(validto) free(validto);
		ldap_pvt_thread_mutex_unlock(glist_mutex);
		return -1;
	}

	((*glist)[*total_inx])->current = 0;
	((*glist)[*total_inx])->mod = 2;
	((*glist)[*total_inx])->dataobj = (DataObj **) calloc(((*glist)[*total_inx])->mod, sizeof(DataObj *));
	if (!((*glist)[*total_inx])->dataobj) {
		fprintf( stderr, "memory allocation failed\n" );
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(dn);
		if (hn) free(hn);
		if (suffix) free(suffix);
		if(keepto) free(keepto);
		if(validto) free(validto);
		free(cmp_obj);
		(void) free_strlist(objclass, obj_no);
		free(objclass);
		if(base) free(base);
		if(path) free(path);
		if(args) free(args);
		if(keepto) free(keepto);
		if(validto) free(validto);
		ldap_pvt_thread_mutex_unlock(glist_mutex);
		return -1;
	}

	((*glist)[*total_inx])->dn = dn;
	((*glist)[*total_inx])->objectclass = objclass;
	((*glist)[*total_inx])->hn = hn;
	((*glist)[*total_inx])->suffix = suffix;
	((*glist)[*total_inx])->port = port;
	((*glist)[*total_inx])->base = base;
	((*glist)[*total_inx])->type = type;
	((*glist)[*total_inx])->path = path;
	((*glist)[*total_inx])->args = get_args(path, base, args);
	((*glist)[*total_inx])->cachetime = cachetime;
	((*glist)[*total_inx])->timelimit = timelimit;
	((*glist)[*total_inx])->sizelimit = sizelimit;
	((*glist)[*total_inx])->tlimit = 0;
	((*glist)[*total_inx])->slimit = 0;
	((*glist)[*total_inx])->stoptime = 0;
	((*glist)[*total_inx])->registerttl = regttl;
	((*glist)[*total_inx])->is_local = local_process(hn, port, local_port);
	if (((*glist)[*total_inx])->is_local == 1)
		sbind_m = ANONYM_ONLY; 
	((*glist)[*total_inx])->sbind_method = sbind_m;
	((*glist)[*total_inx])->keepto = keepto;
	((*glist)[*total_inx])->validto = validto;
	((*glist)[*total_inx])->ld = NULL;
	((*glist)[*total_inx])->res = NULL;
	((*glist)[*total_inx])->lastmodified = 0;
	((*glist)[*total_inx])->purged = 0;

	((*glist)[*total_inx])->activeobject = activeobj;
	((*glist)[*total_inx])->activesearch = activesch;
	((*glist)[*total_inx])->regobj = regobj;
	((*glist)[*total_inx])->state = CACHE_STALE;
	((*glist)[*total_inx])->caching_step = INIT_STEP;
	((*glist)[*total_inx])->lastregistered = current_time();
	ldap_pvt_thread_mutex_init( &((*glist)[*total_inx])->active_obj_mutex);

	if (args) free(args);
	if (cmp_obj) free(cmp_obj);

	(*total_inx)++;

	(void) purge_old_entry(*glist, *total_inx);
	ldap_pvt_thread_mutex_unlock(glist_mutex);

	Debug( LDAP_DEBUG_ANY, "REGISTERING %s:%d (%s)\n", hn, port, suffix );
	return 1;
}


int purge_old_entry(ActiveObj **glist, int total_inx)
{
	int inx, flag=0, cmpres;

	for (inx=0; inx < total_inx; inx++) {
		if (!glist[inx]) {
			continue;
		}

		ldap_pvt_thread_mutex_lock(&(glist[inx])->active_obj_mutex);
		if ((glist[inx])->purged) {
			clear_activeobj(glist[inx]);
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			continue;
		}
		if ((glist[inx])->keepto == NULL)
			cmpres = (current_time() - (glist[inx])->lastregistered > (glist[inx])->registerttl) ? 1 : 0;
		else
			cmpres = cmp_gentime((glist[inx])->keepto);

		if (cmpres > 0) {
			(glist[inx])->purged = 1;
/*
			clear_activeobj(glist[inx]);
			glist[inx] = NULL;
*/
			flag = 1;
		}
		ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
	}
	return flag;
}


int cmp_gentime(char *ktime)
{
	char ctime[16];
	int clen, klen, len, no;
	static int generalized_time(char *, int, time_t, int);

	if (!ktime) return -1;
	if (generalized_time(ctime, 16, current_time(), 0) <= 0)
		return -1;
	if (!ctime) return -1;

	clen = strlen(ctime);
	klen = strlen(ktime);

	/* clen should be klen-1 for the
	   next 7999 years
	*/
	len = (clen < klen) ? clen : klen;
	for (no=0; no<len; no++) {
		if (ctime[no] == ktime[no])
			continue;
		else if (ctime[no] > ktime[no])
			return 1;
		else 
			return 0;
	}

	return 0;
}


/* this function leaves off the suffix "Z" because some buggy
 * strftime() functions seem to misinterpret it as an escape */
static int
generalized_time (char * buffer, int max_len, time_t current_utc_sec, int offset_seconds)
{
	struct tm * component_time;
	time_t utc_seconds;

	utc_seconds = current_utc_sec + offset_seconds;

	component_time = gmtime (&utc_seconds);

	return strftime (buffer, max_len, "%Y%m%d%H%M%S", component_time);
}


/*
int form_all_trailers(ActiveObj **glist, TrailerObj **gtrailer, TrailerObj **ltrailer, int total_inx)
{
	int inx;

	for (inx=0; inx < total_inx; inx++) {
		if (glist[inx] == NULL) continue;
		if (form_trailer(gtrailer, ltrailer, (glist[inx])->dn) == -1)
			return -1;
	}
}
*/


int form_trailer(TrailerObj **gtrailer, TrailerObj **ltrailer, char *dn)
{

	char *par, *tpar, *rdn, *pdn;
	TrailerObj *trailer;

	rdn = giis_dn_relative(dn);
	if (!rdn) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}

	pdn = giis_dn_parent(dn);
	if (!pdn) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(rdn);
		return -1;
	}

	par = (char *) calloc(strlen(rdn) + strlen(pdn) + 3, sizeof(char));
	if (!par) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(rdn);
		free(pdn);
		return -1;
	}

	sprintf(par, "%s, %s", rdn, pdn);
	while (par) {
		if (strlen(par) > 0) {
			if (search_trailer(*gtrailer, par) != 1) {
				if (add_trailer(gtrailer, ltrailer, par) == -1) {
					free(pdn);
					free(rdn);
					free(par);
					return -1;
				}
			}
		}
		tpar = par;
		par = giis_dn_parent(tpar);
		free(tpar);
	}

	free(pdn);
	free(rdn);
	free(par);

	return 0;
}


int print_trailer(TrailerObj *gtrailer)
{

	TrailerObj *current, *tmp;

	current = gtrailer;

	printf("################################################\n");
	while (current) {
		if(current->dn) printf("dn: %s\n", current->dn);
		if(current->cdn) printf("cdn: %s\n", current->cdn);
		if(current->objectclass) printf("objectclass: %s\n", current->objectclass);
		if(current->objectname) printf("objectname: %s\n", current->objectname);
		printf("\n");
		current = current->next;
	}
	printf("################################################\n");
	return 0;
}


char *print_date()
{

	time_t time_v;
	struct tm tm_v, *tmp_v;
	char *buf_p, buf[50], res[50], *tmp, save[50];

	time_v = current_time();
	tmp_v = gmtime_r(&time_v, &tm_v);

/* Stu start */
#if GLOBUS_HAVE_ASCTIME_R_2
        buf_p = asctime_r(&tm_v, buf);
#elif GLOBUS_HAVE_ASCTIME_R_3
        buf_p = asctime_r(&tm_v, buf, 50);
#else
        buf_p = asctime(&tm_v);
        memcpy(&buf[0], buf_p, 50);
        buf_p = &buf[0];
#endif
/* Stu end */

	if (buf_p==NULL) {
		fprintf(stderr, "lastupdate not set\n");
		Debug( LDAP_DEBUG_ANY, "lastupdate not set\n", 0, 0, 0 );
		return NULL;
	}
	else {
		tmp = strrchr(buf, ' ');
		strcpy(save, tmp);
		if (!save) {
			fprintf(stderr, "memory allocation failed\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			return NULL;
		}
		*tmp = '\0';
		sprintf(res, "%s GMT%s", buf, save);
		return (char *) strdup(res);
	}
}


int add_trailer(TrailerObj **gtrailer, TrailerObj **ltrailer, char *dn)
{

	TrailerObj *current, *tmp;
	char *cdn;

	current = (TrailerObj *) calloc(1, sizeof(TrailerObj));
	if (!current) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	current->dn = (char *) strdup(dn);
	if (!current->dn) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	current->cdn = canonicalize_dn(dn);
	if (!current->cdn) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	current->objectclass = (char *) strdup("GlobusStub");
	if (!current->objectclass) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	current->objectname = (char *) strdup(dn);
	if (!current->objectname) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	current->lastupdate = (char *) print_date();
	if (!current->lastupdate) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	current->data = (char *) calloc(strlen(current->dn)*2 + strlen(current->objectclass) + strlen(current->lastupdate) + strlen("dn: ") + strlen("objectclass: ") + strlen("objectname: ") + strlen("lastupdate: ") + 5, sizeof(char));
	if (!current->data) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	sprintf(current->data, "dn: %s\nobjectclass: %s\nobjectname: %s\nlastupdate: %s\n", current->dn, current->objectclass, current->objectname, current->lastupdate);

	if (!*ltrailer) {
		*gtrailer = *ltrailer = current;
	}
	else {
		(*ltrailer)->next = current;
		*ltrailer = current;
	}

	return 0;
}


int search_trailer(TrailerObj *gtrailer, char *dn)
{

	TrailerObj *current, *tmp;
	char *cdn;

	current = gtrailer;

	while(current) {
		tmp = current->next;
		if ((cdn = canonicalize_dn(dn)) == NULL) {
			return 0;
		}
		if (!strcasecmp(cdn, current->cdn)) {
			free(cdn);
			return 1;
		}
		free(cdn);
		current = tmp;
	}
	return 0;
}


int search_glist(ActiveObj **glist, char *hn, int port, char *suffix, char *validto, char *keepto, int total_inx)
{
ActiveObj *current, *tmp;
int inx=0;
char *cg_sfx, *c_sfx;

	int no;

	if (!glist) return 0;

	while(inx < total_inx) {
		if (!(glist[inx])) {
			inx++;
			continue;
		}
		ldap_pvt_thread_mutex_lock(&(glist[inx])->active_obj_mutex);
		if ((glist[inx])->purged) {
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			inx++;
			continue;
		}
		if ((cg_sfx = canonicalize_dn((glist[inx])->suffix)) == NULL)
		{
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			return -1;
		}
		if ((c_sfx = canonicalize_dn(suffix)) == NULL)
		{
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			return -1;
		}
		if (!strcasecmp((glist[inx])->hn, hn) && 
		    !strcasecmp(cg_sfx, c_sfx) &&
		    (glist[inx])->port == port) {
			(glist[inx])->lastregistered = current_time();

			if ((glist[inx])->keepto) free((glist[inx])->keepto);
			if ((glist[inx])->validto) free((glist[inx])->validto);
			if(keepto)
				(glist[inx])->keepto = (char *) strdup(keepto);
			else
				(glist[inx])->keepto = NULL;
			if(validto)
				(glist[inx])->validto = (char *) strdup(validto);
			else
				(glist[inx])->validto = NULL;

			if(cg_sfx) free(cg_sfx);
			if(c_sfx) free(c_sfx);

			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			return 1;
		}
		if(cg_sfx) free(cg_sfx);
		if(c_sfx) free(c_sfx);
		ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);

		inx++;
	}
	return 0;
}


char *
giis_dn_parent(
    char *dn
)
{
	const char	*s;
	int	inquote, inx;

	if( dn == NULL ) {
		return NULL;
	}

	while(*dn && LDAP_SPACE(*dn)) {
		dn++;
	}

	if( *dn == '\0' ) {
		return( NULL );
	}

	/*
	 * assume it is an X.500-style name, which looks like
	 * foo=bar,sha=baz,...
	 */

	inquote = 0;
	for ( s = dn; *s; s++ ) {
		if ( *s == '\\' ) {
			if ( *(s + 1) ) {
				s++;
			}
			continue;
		}
		if ( inquote ) {
			if ( *s == '"' ) {
				inquote = 0;
			}
		} else {
			if ( *s == '"' ) {
				inquote = 1;
			} else if ( LDAP_DNSEPARATOR( *s ) ) {
				inx = 1;
				while( LDAP_SPACE (s[inx])) inx++;
				return( strdup( &s[inx] ) );
			}
		}
	}

	return( strdup( "" ) );
}

char * giis_dn_relative( 
	char	*dn )
{
	char	*s;
	char	*rdn;
	int	inquote;

	if( dn == NULL ) {
		return NULL;
	}

	while(*dn && LDAP_SPACE(*dn)) {
		dn++;
	}

	if( *dn == '\0' ) {
		return( NULL );
	}

	rdn = strdup( dn );

	if( rdn == NULL ) {
		return NULL;
	}

	/*
	 * assume it is an X.500-style name, which looks like
	 * foo=bar,sha=baz,...
	 */

	inquote = 0;

	for ( s = rdn; *s; s++ ) {
		if ( *s == '\\' ) {
			if ( *(s + 1) ) {
				s++;
			}
			continue;
		}
		if ( inquote ) {
			if ( *s == '"' ) {
				inquote = 0;
			}
		} else {
			if ( *s == '"' ) {
				inquote = 1;
			} else if ( LDAP_DNSEPARATOR( *s ) ) {
				*s = '\0';
				return( rdn );
			}
		}
	}

	return( rdn );
}


int print_log(char *filename, char *msg)
{
	FILE *fptr = NULL;

	if ( (fptr = fopen(filename, "a")) == NULL) {
		fprintf(stderr, "log file %s not open\n", filename);
		return -1;
	}

	fprintf(fptr, "%s\n", msg);
	fclose(fptr);
	return 0;
}


int print_glist_log(ActiveObj **glist, char *filename, int total_inx)
{
	int inx=0;
	FILE *fptr = NULL;

	int no;
	static char	*objtypes[] = {"EXEC", "DYNAMIC", "STATIC", "INVALID"};

	if (!glist) return 0;

	if ( (fptr = fopen(filename, "a")) == NULL) {
		fprintf(stderr, "log file %s not open\n", filename);
		return -1;
	}

	while(inx < total_inx) {
		fprintf(fptr, "*************** Entry %d ****************\n", inx+1);
		if (glist[inx] == NULL) {
			fprintf(fptr, "glist[%d] purged\n", inx);
			inx++;
			continue;
		}
		fprintf(fptr, "dn: %s\n", (glist[inx])->dn);

		no = 0;
		if ((glist[inx])->objectclass)
			while((glist[inx])->objectclass[no]) {
				fprintf(fptr, "objectclass[%d]: %s\n", no, (glist[inx])->objectclass[no]);
				no++;
			}

		if ((glist[inx])->hn)
			fprintf(fptr, "hn: %s\n", (glist[inx])->hn);
		if ((glist[inx])->port)
			fprintf(fptr, "port: %d\n", (glist[inx])->port);
		if ((glist[inx])->type)
			fprintf(fptr, "type: %s\n", objtypes[(glist[inx])->type]);
		if ((glist[inx])->path) 
			fprintf(fptr, "path: %s\n", (glist[inx])->path);
		if ((glist[inx])->base) 
			fprintf(fptr, "base: %s\n", (glist[inx])->base);
		no = 0;
		if ((glist[inx])->args)
			while((glist[inx])->args[no]) {
				fprintf(fptr, "args[%d]: %s\n", no, (glist[inx])->args[no]);
				no++;
			}

		if ((glist[inx])->cachetime >= 0)
			fprintf(fptr, "cachetime: %d\n", (glist[inx])->cachetime);
		if ((glist[inx])->timelimit >= 0)
			fprintf(fptr, "timelimit: %d\n", (glist[inx])->timelimit);
		if ((glist[inx])->sizelimit >= 0)
			fprintf(fptr, "sizelimit: %d\n", (glist[inx])->sizelimit);
		if ((glist[inx])->tlimit >= 0)
			fprintf(fptr, "tlimit: %d\n", (glist[inx])->tlimit);
		if ((glist[inx])->slimit >= 0)
			fprintf(fptr, "slimit: %d\n", (glist[inx])->slimit);
		if ((glist[inx])->stoptime >= 0)
			fprintf(fptr, "stoptime: %d\n", (glist[inx])->stoptime);
		if ((glist[inx])->lastmodified)
			fprintf(fptr, "lastmodified: %d\n", (glist[inx])->lastmodified);
		if ((glist[inx])->activeobject >= 0)
			fprintf(fptr, "activeobject: %d\n", (glist[inx])->activeobject);
		if ((glist[inx])->activesearch >= 0)
			fprintf(fptr, "activesearch: %d\n", (glist[inx])->activesearch);
		if ((glist[inx])->registerttl >= 0)
			fprintf(fptr, "registerttl: %d\n", (glist[inx])->registerttl);
		if ((glist[inx])->validto)
			fprintf(fptr, "validto: %d\n", (glist[inx])->validto);
		if ((glist[inx])->keepto)
			fprintf(fptr, "keepto: %d\n", (glist[inx])->keepto);
		if ((glist[inx])->lastregistered >= 0)
			fprintf(fptr, "lastregistered: %d\n", (glist[inx])->lastregistered);
		inx++;
	}
	fprintf(fptr, "*****************************************\n");
	return 0;
}


int
add_policy (char ***rpolicy, int *total_rpolicy, ldap_pvt_thread_mutex_t *rpolicy_mutex, char *obj)
{

	int		objclass_no, obj_no, objclass_inx;
	int		data_size = GIIS_DATA_SIZE;
	int		ndata_size = GIIS_DATA_SIZE;
	int		no, notf, regf, obj_size;

	char 		*tmp, *policydata;
	char		**objclass, *cmp_obj;

	notf = 0;
	regf = 0;

	obj_size = strlen(obj);
	cmp_obj = (char *) calloc(obj_size+1, sizeof(char));
	if (!cmp_obj) {
		fprintf( stderr, "memory allocation failed\n" );
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}
	for (no=0; no<obj_size; no++)
		cmp_obj[no] = tolower(obj[no]);
	cmp_obj[no] = 0;

	objclass_no = MAX_OBJCLASS_NO;
	if ((objclass = (char **) calloc(objclass_no, sizeof(char *))) == NULL) {
		fprintf( stderr, "memory allocation failed\n" );
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(cmp_obj);
		return -1;
	}

	obj_no = 0;
	objclass_inx = 0;

	tmp = get_attribute(cmp_obj, "objectclass:", &objclass_inx);
	while( tmp ) {
		if (obj_no >= objclass_no) {
			objclass_no += MAX_OBJCLASS_NO;
			if ((objclass = (char **) realloc(objclass, objclass_no * sizeof(char *))) == NULL) {
				fprintf(stderr, "memory allocation failed\n");
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				free(cmp_obj);
				(void) free_strlist(objclass, obj_no);
				free(objclass);
				return -1;
			}
		}
		objclass[obj_no++] = tmp;
		if (!strcasecmp(tmp, "MdsRegistrationPolicy"))
			regf = 1;
		tmp = get_attribute(cmp_obj, "objectclass:", &objclass_inx);
	}

	if (obj_no >= objclass_no) {
		objclass_no += 1;
		if ((objclass = (char **) realloc(objclass, objclass_no * sizeof(char *))) == NULL) {
			fprintf(stderr, "memory allocation failed\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			free(cmp_obj);
			(void) free_strlist(objclass, obj_no);
			return -1;
		}
	}
	objclass[obj_no] = NULL;

	policydata = get_attribute(obj, "policydata:", NULL);
	if (!policydata) {
		fprintf(stderr, "policydata not found\n");
		Debug( LDAP_DEBUG_ANY, "policydata not found\n", 0, 0, 0 );
		free(cmp_obj);
		(void) free_strlist(objclass, obj_no);
		free(objclass);
		return 0;
	}


	if(regf) {
		if ( *total_rpolicy && !(*total_rpolicy % data_size) ) {
			data_size = *total_rpolicy + GIIS_DATA_SIZE;
			*rpolicy = (char **) realloc(*rpolicy, data_size * sizeof(char *));
			if (!*rpolicy) {
				fprintf( stderr, "memory allocation failed\n" );
				Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
				free(cmp_obj);
				(void) free_strlist(objclass, obj_no);
				free(objclass);
				if(policydata) free(policydata);
				return -1;
			}
		}

		ldap_pvt_thread_mutex_lock( rpolicy_mutex );
		(*rpolicy)[*total_rpolicy] = policydata;
		(*total_rpolicy)++;
		ldap_pvt_thread_mutex_unlock( rpolicy_mutex );
	}

	free(cmp_obj);
	(void) free_strlist(objclass, obj_no);
	free(objclass);
	
	return 1;
}

int get_local_port()
{
	int port;
	char *arg = NULL, *pstr1 = NULL, *pstr2 = NULL;
	FILE *fptr;

	if ( slapd_args_file == NULL ) {
		fprintf( stderr, "slapd_args_file not found\n" );
		Debug( LDAP_DEBUG_ANY, "slapd_args_file not found\n", 0, 0, 0 );
		return( -1 );
        }

	if ( (fptr = fopen( slapd_args_file, "r" )) == NULL ) {
		fprintf (stderr, "Can't open %s\n", slapd_args_file);
		Debug (LDAP_DEBUG_ANY, "Can't open %s\n", slapd_args_file, 0, 0 );
		return -1;
	}

	arg = getstrent(fptr);
	if (!arg) {
		fprintf (stderr, "Invalid args file (%s)\n", slapd_args_file);
		Debug (LDAP_DEBUG_ANY, "Invalid args file (%s)\n", slapd_args_file, 0, 0 );
		fclose(fptr);
		return -1;
	}
	fclose(fptr);

	pstr1 = strrchr(arg, ':');
	if (!pstr1) {
		fprintf (stderr, "Invalid args file (%s)\n", slapd_args_file);
		Debug (LDAP_DEBUG_ANY, "Invalid args file (%s)\n", slapd_args_file, 0, 0 );
		free(arg);
		return -1;
	}
	pstr2 = strrchr(arg, ' ');
	if (!pstr2) {
		fprintf (stderr, "Invalid args file (%s)\n", slapd_args_file);
		Debug (LDAP_DEBUG_ANY, "Invalid args file (%s)\n", slapd_args_file, 0, 0 );
		free(arg);
		return -1;
	}
	*pstr2 = '\0';

	errno = 0;
	port = atoi(pstr1+1);
	if (errno != 0) {
		fprintf (stderr, "Invalid args file (%s)\n", slapd_args_file);
		Debug (LDAP_DEBUG_ANY, "Invalid args file (%s)\n", slapd_args_file, 0, 0 );
		free(arg);
		return -1;
	}

	free(arg);

	return port;
}

int local_process(char* reghost, int regport, int myport)
{

	struct hostent *host_ptr = NULL;
	char reg_hostname[MAX_HOSTNAME], my_hostname[MAX_HOSTNAME];
	char myhost[MAX_HOSTNAME];

	/* 
	   if the giis' port number can't be found, consider it
           as the same port number as the registrant
        */
	if (myport != -1 && regport != myport)
		return 0;

	if( gethostname(myhost, MAX_HOSTNAME) != 0) {
		return -1;
	}

	host_ptr = gethostbyname(reghost);
	if(host_ptr == NULL)
	{
		return -1;
	}
	host_ptr = gethostbyaddr(*host_ptr->h_addr_list, sizeof(struct in_addr), AF_INET);
	if(host_ptr == NULL)
	{
		return -1;
	}
	strcpy(reg_hostname, host_ptr->h_name);
   
	host_ptr = gethostbyname(myhost);
	if(host_ptr == NULL)
	{
		return -1;
	}
	host_ptr = gethostbyaddr(*host_ptr->h_addr_list, sizeof(struct in_addr), AF_INET);
	if(host_ptr == NULL)
	{
		return -1;
	}
	strcpy(my_hostname, host_ptr->h_name);

	return !strcasecmp(reg_hostname, my_hostname);
}

int check_peer_name(char *peer_name)
{

	char myhost[MAX_HOSTNAME], my_hostname[MAX_HOSTNAME];
	char peerhoststr[MAX_HOSTNAME], peer_hostname[MAX_HOSTNAME];
	struct hostent *host_ptr = NULL;
	char *pstr1, *pstr2;
	int port;

	if(!peer_name) return 0;
	strcpy(peerhoststr, peer_name);

	pstr1 = strrchr(peerhoststr, '=');
	if (!pstr1) {
		return 0;
	}

	pstr2 = strrchr(pstr1, ':');
	if (!pstr2) {
		return 0;
	}

	*pstr2 = '\0';

	host_ptr = gethostbyname(pstr1+1);
	if(host_ptr == NULL)
	{
		return -1;
	}
	host_ptr = gethostbyaddr(*host_ptr->h_addr_list, sizeof(struct in_addr), AF_INET);
	if(host_ptr == NULL)
	{
		return -1;
	}
	strcpy(peer_hostname, host_ptr->h_name);

	if( gethostname(myhost, MAX_HOSTNAME) != 0) {
		return -1;
	}
	host_ptr = gethostbyname(myhost);
	if(host_ptr == NULL)
	{
		return -1;
	}
	host_ptr = gethostbyaddr(*host_ptr->h_addr_list, sizeof(struct in_addr), AF_INET);
	if(host_ptr == NULL)
	{
		return -1;
	}
	strcpy(my_hostname, host_ptr->h_name);
	return !strcasecmp(peer_hostname, my_hostname);
}

