/* search.c - giis backend search function */
/*
$Header: /home/globdev/CVS/globus-packages/mds/openldap/giis-ldapmodules/search.c,v 1.16 2003/03/22 02:50:59 jslee Exp $
$Log: search.c,v $
Revision 1.16  2003/03/22 02:50:59  jslee
adding allowstaledata yes/no

Revision 1.15  2003/02/05 09:11:10  jslee
fixing threads runout - bugzilla #644

Revision 1.14  2003/01/10 23:33:34  jslee
changing locking, adding double buffering, and changing cache data structure

Revision 1.13  2002/11/26 02:18:16  jslee
fixing memory leaks in case of sizelimit/timelimit reached

Revision 1.12  2002/11/15 18:46:51  jslee
fixing memory leak - stts in gen_reg_obj

Revision 1.11  2002/10/16 01:17:01  jslee
fixing file descriptor leaks

Revision 1.10  2002/09/25 23:18:16  jslee
initializing a variable (ubuf) in giis_back_search

Revision 1.9  2002/08/19 18:16:18  benc

giisregistrationstatus query was returning an incorrect value, because
it was using the wrong field of the registration struct.

modified to use the correct field.

see bugzilla 243

Revision 1.8  2002/08/14 22:40:27  benc
Merge MDS2.2 into trunk.

Revision 1.7.20.1  2002/08/07 03:56:02  benc
Merged (hopefully) all of the mds_2_2_branch work onto this new branch.

Compiles and runs on Linux.

Revision 1.7.2.5  2002/06/13 18:02:26  jslee
changing the way of publishing bindmethod

Revision 1.7.2.4  2002/06/12 22:09:23  jslee
adding mutual authentication functions

Revision 1.7.2.3  2002/05/20 22:17:16  jslee
adding syslog messages to the giis backend

Revision 1.7.2.2  2002/05/13 21:14:28  jslee
removing debugging printouts

Revision 1.7.2.1  2002/05/13 21:10:48  jslee
modifying fetching routines

Revision 1.1.1.1.2.3  2002/04/18 18:57:39  jslee
modifying stoptime and registrant's tlimit constraints

Revision 1.1.1.1.2.2  2002/02/26 02:46:11  jslee
debugging repeated GlobusStub bug

Revision 1.1.1.1.2.1  2002/01/14 22:07:32  jslee
debugging caching mechanism

Revision 1.1.1.1  2002/01/10 02:10:09  jslee
importing globus-beta-branch to the main trunk

Revision 1.2.4.29  2001/10/30 02:59:07  jslee
removing matched

Revision 1.2.4.28  2001/10/30 02:39:40  jslee
fixing search_fill concurrency bug

Revision 1.2.4.27  2001/10/30 01:18:35  jslee
fixing concurrency problems

Revision 1.2.4.26  2001/10/29 00:41:09  jslee
fixing concurrency bug

Revision 1.2.4.25  2001/10/26 22:12:04  jslee
debugging memory leaks in get_obj_from_entry

Revision 1.2.4.24  2001/10/26 18:58:33  jslee
debugging deadlock

Revision 1.2.4.23  2001/10/26 02:36:40  jslee
fixing memory leaks

Revision 1.2.4.22  2001/10/25 23:25:40  jslee
debugging concurrency problems

Revision 1.2.4.21  2001/10/25 18:27:36  jslee
fixing concurrency problems

Revision 1.2.4.20  2001/10/23 23:43:47  jslee
adding routine to check the ld value

Revision 1.2.4.19  2001/10/23 01:49:20  jslee
changing the symantics of sizelimit:\nsizelimit of 0 means no sizelimit

Revision 1.2.4.18  2001/10/19 18:53:57  jslee
modifying multiple query handling routines

Revision 1.2.4.17  2001/10/19 12:17:41  jslee
modifying mutexes for multiple queries

Revision 1.2.4.16  2001/10/19 08:54:42  jslee
debugging registration process for multiple layer of giis

Revision 1.2.4.15  2001/10/15 21:21:06  jslee
minor changes for validto function

Revision 1.2.4.14  2001/10/15 21:12:58  jslee
adding Mds-keepto function in dispatch_active_obj

Revision 1.2.4.13  2001/10/13 06:11:42  jslee
enabling multiple giis backends per slapd\nremoving all the global variables

Revision 1.2.4.12  2001/10/10 22:01:59  jslee
modifying to use openldap's str2filter and filter_free and memory cleaning

Revision 1.2.4.11  2001/10/10 01:52:27  jslee
fixing intermediate nodes creation bugs

Revision 1.2.4.10  2001/10/07 00:03:41  jslee
debugging giis caching

Revision 1.2.4.9  2001/10/06 00:49:09  jslee
adding dn relabling function

Revision 1.2.4.8  2001/10/05 21:02:17  jslee
modification for edg

Revision 1.2.4.7  2001/10/03 02:17:46  jslee
debugging search.c to make multiple level of giis work

Revision 1.2.4.6  2001/09/30 09:58:58  jslee
dealing with funny behavior of openldap, which inserts CRspace after the 78th character of a string

Revision 1.2.4.5  2001/09/28 23:04:55  jslee
modifying ldap_search call

Revision 1.2.4.4  2001/09/28 14:52:25  jslee
removing debugging messages

Revision 1.2.4.3  2001/09/28 13:53:47  jslee
adjusting to restructured dn

Revision 1.2.4.2  2001/09/26 21:18:36  smartin
committing merge from main repository trunk to beta branch

Revision 1.3  2001/09/24 15:13:08  smartin
committing merge from globus-beta-branch

Revision 1.2.4.1  2001/09/21 19:50:37  meisu
1) rename giis.h to slapd_giis.h
2) change the init function in init.c to match with libback_giis.la

Revision 1.2  2001/09/06 00:51:40  jslee
add policy checking & modifying timeout checking

Revision 1.7  2001/09/06 00:16:43  june
modify timeout checking & fixing memory leaks

Revision 1.6  2001/08/28 23:52:29  june
memory leaks

Revision 1.5  2001/08/20 05:19:42  june
add purge & registration policy functions

Revision 1.4  2001/08/03 21:13:53  june
adding intermediate objects

Revision 1.1.1.1  2001/07/21 01:53:49  june
Import giis backend

Revision 1.1.1.1  2001/07/06 21:11:15  mei
1) splitting out back-giis from the openldap 2.0.8-patched into a standalone
   directory that can generate 'dynamic modules' that can be used by the
   openldap's slapd (checked against 2.0.11 already)

Revision 1.8  2001/05/30 22:07:31  june
fixing read_and_send_results bug

Revision 1.7  2001/05/24 03:04:24  june
remove debug printfs

Revision 1.6  2001/05/24 01:05:06  june
gridmap checking & timelimit debugging

Revision 1.5  2001/04/20 03:34:21  june
fixing giis timing bug

Revision 1.4  2001/04/19 22:11:35  june
fixing first object disappearing bug

Revision 1.3  2001/04/19 17:54:23  june
updating dispatching routines

Revision 1.2  2001/04/02 20:18:40  june
debugging bind_dn

Revision 1.1  2001/03/24 00:08:38  june
adding giis backend

Revision 1.1  2001/03/22 03:01:25  june
add giis backend

Revision 1.5  2000/10/03 23:11:56  june
add bind_dn

Revision 1.4  2000/09/23 00:06:06  june
add forkandexec

Revision 1.3  2000/09/13 02:11:50  june
resolve changes between 2.0 & 2.0.1

Revision 1.2  2000/09/12 22:41:39  june
Add giis backend
*/


#include "portable.h"

#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include <ac/ctype.h>
#include <ac/socket.h>
#include <ac/string.h>
#include <ac/time.h>

#include "slap.h"
#include "slapd_giis.h"
#include <ldap_pvt.h>

#ifdef HAVE_CYRUS_SASL
#include <limits.h>
#include <sasl.h>
#include <lutil.h>
#include "lutil_ldap.h"
#include "ldif.h"
#include "ldap_defaults.h"
#endif

int
giis_back_search(
    Backend	*be,
    Connection	*conn,
    Operation	*op,
    const char	*base,
    const char	*nbase,
    int		scope,
    int		deref,
    int		slimit,
    int		tlimit,
    Filter	*filter,
    const char	*filterstr,
    char	**attrs,
    int		attrsonly
)
{
	Entry		*e;
	char		*s;
	time_t		stoptime;

	int i;
	int err = LDAP_SUCCESS;
	int id;

	char *str = NULL;
	char *binddn;

	pid_t pid;
	pid_t cpid;
	int status;

	FILE *rfp;
	FILE *wfp;

	LDAP *ld;

	int		create_new, inx, sfxm, jj;
	FILE		*fptr = NULL;
	char		*dn, *data, *obj, *path, *sfx;
	int		cur_inx, cnt;
	char		*authcid, *ubuf = NULL;
	TrailerObj	*current = NULL;

	int		*search_fill;

	LDAPMessage	*res, *entry;
	int		len, msgtype, no, ub;
	char		*tobject, *srch_object, *get_obj_from_entry(LDAP *, LDAPMessage *);
	char		*tsrch_object, *tobj = NULL;
	char		*objclass;
	struct timeval	tv;
	int		start_time = current_time();
	int		search_timed_out;

	AttributeDescription *ad_objectClass = slap_schema.si_ad_objectClass;
	GiisDT *gdt = (GiisDT *) be->be_private;

	/* GiisDT field copies */
	int		giisallow_anonym;
	char		*giisconfigfile;
	ActiveObj 	**glist;
	int		total_inx;
	int		local_port;
	int		allow_stale_data;
	char		*giisgiven_sfx;
	DataObj		*cdataobj=NULL, *sdataobj=NULL, *ndataobj=NULL, *edataobj=NULL;
	char		*peer_name;

	authcid = (char *) strchr(op->o_dn, '=');
	if ( authcid && strlen(authcid) >= 1 ) 
		authcid += 1;

	if ( gdt == NULL ) {
		send_ldap_result( conn, op, LDAP_UNWILLING_TO_PERFORM, NULL,
		    "search not implemented", NULL, NULL );
		Debug( LDAP_DEBUG_ANY, "search not implemented\n", 0, 0, 0 );
		return( -1 );
        }

	/* initialize GiisDT fields locally */
	ldap_pvt_thread_mutex_lock(&gdt->glist_mutex);
	giisallow_anonym = gdt->giisallow_anonym;
	total_inx = gdt->total_inx;
	glist = *gdt->glist;
	giisconfigfile = gdt->giisconfigfile;
	giisgiven_sfx = gdt->giisgiven_sfx;
	local_port = gdt->local_port;
	allow_stale_data = gdt->allow_stale_data;
	ldap_pvt_thread_mutex_unlock(&gdt->glist_mutex);

	if (!giisallow_anonym && check_peer_name(conn->c_peer_name) != 1) {
	 	if ( authcid == NULL || globus_gss_assist_gridmap(authcid, &ubuf)!=0) {
			send_ldap_result( conn, op, LDAP_UNWILLING_TO_PERFORM, NULL, "access denied: gridmap lookup failed", NULL, NULL );
			Debug( LDAP_DEBUG_ANY, "access denied: gridmap lookup failed\n", 0, 0, 0 );
			if (ubuf) free(ubuf);
			return -1;
		}
		if (ubuf) free(ubuf);
	}

	if (!glist) {
		fprintf (stderr, "initialization error\n");
		Debug( LDAP_DEBUG_ANY, "Initialization error\n", 0, 0, 0 );
		send_ldap_result( conn, op, LDAP_UNWILLING_TO_PERFORM, NULL,
		    "Initialization error", NULL, NULL );
		return -1;
	}

	if ( total_inx == 0 ) {
		send_ldap_result( conn, op, err, NULL, NULL, NULL, NULL );
		return 0;
        }

	if ( scope == 0 && attrs != NULL && *attrs != NULL && !strcasecmp(*attrs, "giisregistrationstatus")) {
		char *sres;
		int no=0;
		Entry *ent;

		for (no=0; no < total_inx; no++) {
			if (!glist[no]) {
				continue;
			}
			ldap_pvt_thread_mutex_lock(&(glist[no])->active_obj_mutex);
			if ((glist[no])->purged) {
				ldap_pvt_thread_mutex_unlock(&(glist[no])->active_obj_mutex);
				continue;
			}

			if ( (sres = gen_reg_obj(glist[no])) == NULL) {
				Debug( LDAP_DEBUG_ANY, "Publishing registration status failed\n", 0, 0, 0 );
				send_ldap_result( conn, op, LDAP_UNWILLING_TO_PERFORM, NULL, "Publishing registration status failed\n", NULL, NULL );
				ldap_pvt_thread_mutex_unlock(&(glist[no])->active_obj_mutex);
				return -1;
			}
			ldap_pvt_thread_mutex_unlock(&(glist[no])->active_obj_mutex);
			ent = str2entry( sres );
			send_search_entry( be, conn, op, ent, NULL, 0, NULL );
			if (ent) entry_free( ent );
			if (sres) free (sres);
		}
		send_ldap_result( conn, op, err, NULL, NULL, NULL, NULL );
		return 0;
	}

	tlimit = (tlimit > be->be_timelimit || tlimit < 1) ? 
			be->be_timelimit : tlimit;
	stoptime = current_time() + tlimit;
	slimit = (slimit > be->be_sizelimit || slimit < 1) ? 
			be->be_sizelimit : slimit;

	cur_inx = 0;
	inx = 0;

	search_fill = (int *) calloc(total_inx, sizeof(int));
	if(!search_fill) {
		fprintf(stderr, "memory allocation error\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		send_ldap_result( conn, op, LDAP_UNWILLING_TO_PERFORM, NULL,
		    "memory allocation error", NULL, NULL );
		return -1;
	}
	for(jj=0; jj<total_inx; jj++)
		search_fill[jj] = 0;

	while (inx < total_inx) {
		if (!glist[inx]) {
			inx++;
			continue;
		}
		ldap_pvt_thread_mutex_lock(&(glist[inx])->active_obj_mutex);
		if ((glist[inx])->purged) {
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			inx++;
			continue;
		}
		if ((glist[inx])->timelimit > 0)
			(glist[inx])->tlimit = (glist[inx])->timelimit;
		else
			(glist[inx])->tlimit = tlimit;

		if ((glist[inx])->sizelimit > 0)
			(glist[inx])->slimit = (glist[inx])->sizelimit;
		else
			(glist[inx])->slimit = -1;
		(glist[inx])->stoptime = current_time() + (glist[inx])->tlimit;

		if((glist[inx])->state == CACHE_FILL) {
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			search_fill[inx] = 1;
			inx++;
			continue;
		}

		sfxm = dispatch_active_obj((glist[inx])->dn, nbase, scope, (glist[inx])->validto);
		if (sfxm == -1) {
			if(search_fill) free(search_fill);
			(glist[inx])->state = CACHE_STALE;
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			return -1;
		}
		if(!sfxm) {
			(glist[inx])->state = CACHE_STALE;
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			inx++;
			continue;
		}
		if(is_old(glist[inx]))
			(glist[inx])->state = CACHE_STALE;
		else
			(glist[inx])->state = CACHE_READY;

		if((glist[inx])->state == CACHE_READY) {
			int cache_res, reg_slimit;
			DataObj *data = NULL;

			reg_slimit = (glist[inx])->slimit;
			if ((glist[inx])->dataobj[(glist[inx])->current] == NULL) {
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
				search_fill[inx] = 0;
				inx++;
				continue;
			}
			data = (glist[inx])->dataobj[(glist[inx])->current];
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);

			cur_inx = 0;
			cnt = 0;
			search_fill[inx] = 0;
			cache_res = get_cached_data(data, &reg_slimit, &(glist[inx])->purged, giisgiven_sfx,
						stoptime, be, conn, op, nbase, scope,
						&slimit, filter, attrs, attrsonly);
				
			if(cache_res == -1) {
				if(search_fill) free(search_fill);
				return -1;
			}
		}

		else if ((glist[inx])->state == CACHE_STALE) {

			if ( (glist[inx])->is_local == 1 && ldap_pvt_thread_pool_availablethreads(&connection_pool) <= 0 ) {
				fprintf(stderr, "no available threads - search skipped for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port);
				Debug( LDAP_DEBUG_ANY, "no available threads - search skipped for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port, 0 );
				(glist[inx])->state = CACHE_STALE;
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
				inx++;
				continue;
			}
			/* if not NULL, other thread inited it already */
			if((glist[inx])->ld != NULL) {
				switch ((glist[inx])->caching_step) {
				case INIT_STEP:
				case BINDING_STEP:
					goto init_done;
				case SEARCHING_STEP:
					goto binding_done;
				default:
					goto init_done;
				}
			}

			(glist[inx])->caching_step = INIT_STEP;

			(glist[inx])->ld = ldap_init( (glist[inx])->hn, (glist[inx])->port );
			if (!(glist[inx])->ld) {
				fprintf(stderr, "ldap_init failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port );
				Debug( LDAP_DEBUG_ANY, "ldap_init failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port, 0 );
				(glist[inx])->state = CACHE_STALE;
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
				inx++;
				continue;
			}

init_done:

			(glist[inx])->caching_step = BINDING_STEP;

			if ( (glist[inx])->sbind_method == AUTHC_ONLY || (glist[inx])->sbind_method == AUTHC_FIRST ) {
#ifdef HAVE_CYRUS_SASL
				void *defaults;
				int rc, version;
				const char *sasl_mech;
				char *binddn=NULL;
				unsigned sasl_flags = LDAP_SASL_AUTOMATIC;

				version = LDAP_VERSION3;
				if( ldap_set_option( (glist[inx])->ld, LDAP_OPT_PROTOCOL_VERSION, &version ) != LDAP_OPT_SUCCESS )
				{
					if ((glist[inx])->sbind_method == AUTHC_ONLY) {
						Debug( LDAP_DEBUG_ANY, "Could not set LDAP_OPT_PROTOCOL_VERSION %d\n", version, 0, 0 );
						(glist[inx])->state = CACHE_STALE;
						ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
						inx++;
						continue;
					}
					else
						goto simple_authc;
				}

				defaults = lutil_sasl_defaults( (glist[inx])->ld, NULL, NULL, NULL, NULL, NULL );

				ldap_get_option( (glist[inx])->ld, LDAP_OPT_X_SASL_MECH, &sasl_mech);

				rc = ldap_sasl_interactive_bind_s( 
					(glist[inx])->ld,
					binddn,
					sasl_mech,
					NULL,
					NULL,
					sasl_flags,
					lutil_sasl_interact,
					defaults 
				);


				if( rc != LDAP_SUCCESS ) {
					if ((glist[inx])->sbind_method == AUTHC_ONLY) {
						Debug ( LDAP_DEBUG_ANY, "ldap_sasl_interactive_bind_s failed with the result %d\n", rc, 0, 0 );
						(glist[inx])->state = CACHE_STALE;
						ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
						inx++;
						continue;
					}
					else
						goto simple_authc;
				}
				else 
					goto binding_done;

#else
				if ((glist[inx])->sbind_method == AUTHC_ONLY) {
					Debug ( LDAP_DEBUG_ANY, "%s: not compiled with SASL support\n", "slapd", 0, 0 );
					(glist[inx])->state = CACHE_STALE;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					inx++;
					continue;
				}
				else
					goto simple_authc;
#endif
			}

simple_authc:
			if ( (glist[inx])->sbind_method == ANONYM_ONLY || (glist[inx])->sbind_method == AUTHC_FIRST ) {
				if ( ldap_bind( (glist[inx])->ld, (glist[inx])->dn, NULL, LDAP_AUTH_SIMPLE ) == -1 ) {
					fprintf( stderr, "ldap_bind failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port );
					Debug( LDAP_DEBUG_ANY, "ldap_bind failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port, 0 );
					(glist[inx])->state = CACHE_STALE;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					inx++;
					continue;
				}
			}
binding_done:

			(glist[inx])->caching_step = SEARCHING_STEP;

			if (( id = ldap_search( (glist[inx])->ld, (glist[inx])->suffix, 2, "(objectclass=*)", NULL, 0 )) == -1 ) {
                               	fprintf( stderr, "ldap_search failed\n" );
				Debug( LDAP_DEBUG_ANY, "ldap_search failed\n", 0, 0, 0 );
				(glist[inx])->state = CACHE_STALE;
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			} else {
				(glist[inx])->msgid = id;
                               	printf( "Searching ldap://%s:%d -b \"%s\" started with id %d\n", (glist[inx])->hn, (glist[inx])->port, (glist[inx])->suffix, id );
				(glist[inx])->state = CACHE_FILL;
				(glist[inx])->caching_step = INIT_STEP;
				search_fill[inx] = 1;
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			}
		}
		inx++;
	}

	while(no_fetches(glist, total_inx, search_fill)) {
		inx = total_inx - 1;
		while ( (inx = next_inx(glist, total_inx, search_fill, inx)) >= 0) {
			if (inx == -1) {
				break;
			}
			ldap_pvt_thread_mutex_lock(&(glist[inx])->active_obj_mutex);
			if ((glist[inx])->purged) {
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
				continue;
			}

			if((glist[inx])->state == CACHE_READY) {
				int cache_res, reg_slimit;
				char *data = NULL;

				reg_slimit = (glist[inx])->slimit;
				if ((glist[inx])->dataobj[(glist[inx])->current] == NULL) {
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					search_fill[inx] = 0;
					continue;
				}
				data = (glist[inx])->dataobj[(glist[inx])->current];
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);

				cur_inx = 0;
				cnt = 0;
				search_fill[inx] = 0;
				cache_res = get_cached_data(data, &reg_slimit, &(glist[inx])->purged, giisgiven_sfx,
							stoptime, be, conn, op, nbase, scope,
							&slimit, filter, attrs, attrsonly);

				if(cache_res == -1) {
					if(search_fill) free(search_fill);
					return -1;
				}
				else
					continue;
			}

			else if((glist[inx])->state == CACHE_STALE) {
				if ( (glist[inx])->is_local == 1 && ldap_pvt_thread_pool_availablethreads(&connection_pool) <= 0 ) {
					fprintf(stderr, "no available threads - search skipped for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port);
					Debug( LDAP_DEBUG_ANY, "no available threads - search skipped for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port, 0 );
					(glist[inx])->state = CACHE_STALE;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					continue;
				}

				if((glist[inx])->ld != NULL) {
					switch ((glist[inx])->caching_step) {
					case INIT_STEP:
					case BINDING_STEP:
						goto init_done1;
					case SEARCHING_STEP:
						goto binding_done1;
					default:
						goto init_done1;
					}
				}
				else if ( current_time() > stoptime || current_time() > start_time + (glist[inx])->tlimit ) {
					fprintf(stderr, "search already timed out - search skipped for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port);
					Debug( LDAP_DEBUG_ANY, "search already timed out - search skipped for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port, 0 );
					search_fill[inx] = 0;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					continue;
				}

				(glist[inx])->caching_step = INIT_STEP;

				(glist[inx])->ld = ldap_init( (glist[inx])->hn, (glist[inx])->port );
				if (!(glist[inx])->ld) {
					fprintf(stderr, "ldap_init failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port );
					Debug( LDAP_DEBUG_ANY, "ldap_init failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port, 0 );
					(glist[inx])->state = CACHE_STALE;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					continue;
				}

init_done1:

				(glist[inx])->caching_step = BINDING_STEP;

				if ( (glist[inx])->sbind_method == AUTHC_ONLY || (glist[inx])->sbind_method == AUTHC_FIRST ) {
#ifdef HAVE_CYRUS_SASL
					void *defaults;
					int rc, version;
					const char *sasl_mech;
					char *binddn=NULL;
					unsigned sasl_flags = LDAP_SASL_AUTOMATIC;


					version = LDAP_VERSION3;
					if( ldap_set_option( (glist[inx])->ld, LDAP_OPT_PROTOCOL_VERSION, &version ) != LDAP_OPT_SUCCESS )
					{
						if ((glist[inx])->sbind_method == AUTHC_ONLY) {
							Debug( LDAP_DEBUG_ANY, "Could not set LDAP_OPT_PROTOCOL_VERSION %d\n", version, 0, 0 );
							(glist[inx])->state = CACHE_STALE;
							ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
							inx++;
							continue;
						}
						else
							goto simple_authc1;
					}

					defaults = lutil_sasl_defaults( (glist[inx])->ld, NULL, NULL, NULL, NULL, NULL );

					ldap_get_option( (glist[inx])->ld, LDAP_OPT_X_SASL_MECH, &sasl_mech);

					rc = ldap_sasl_interactive_bind_s( 
						(glist[inx])->ld,
						binddn,
						sasl_mech,
						NULL,
						NULL,
						sasl_flags,
						lutil_sasl_interact,
						defaults 
					);


					if( rc != LDAP_SUCCESS ) {
						if ((glist[inx])->sbind_method == AUTHC_ONLY) {
							Debug ( LDAP_DEBUG_ANY, "ldap_sasl_interactive_bind_s failed with the result %d\n", rc, 0, 0 );
							(glist[inx])->state = CACHE_STALE;
							ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
							inx++;
							continue;
						}
						else
							goto simple_authc1;
					}
					else 
						goto binding_done1;

#else
					if ((glist[inx])->sbind_method == AUTHC_ONLY) {
						Debug ( LDAP_DEBUG_ANY, "%s: not compiled with SASL support\n", "slapd", 0, 0 );
						(glist[inx])->state = CACHE_STALE;
						ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
						inx++;
						continue;
					}
					else
						goto simple_authc1;
#endif
				}

simple_authc1:
				if ( (glist[inx])->sbind_method == ANONYM_ONLY || (glist[inx])->sbind_method == AUTHC_FIRST ) {
					if ( ldap_bind( (glist[inx])->ld, (glist[inx])->dn, NULL, LDAP_AUTH_SIMPLE ) == -1 ) {
						fprintf( stderr, "ldap_bind failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port );
						Debug( LDAP_DEBUG_ANY, "ldap_bind failed for ldap://%s:%d\n", (glist[inx])->hn, (glist[inx])->port, 0 );
						(glist[inx])->state = CACHE_STALE;
						ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
						inx++;
						continue;
					}
				}
binding_done1:

				(glist[inx])->caching_step = SEARCHING_STEP;

				if (( id = ldap_search( (glist[inx])->ld, (glist[inx])->suffix, 2, "(objectclass=*)", NULL, 0 )) == -1 ) {
                                	fprintf( stderr, "ldap_search failed\n" );
					Debug( LDAP_DEBUG_ANY, "ldap_search failed\n", 0, 0, 0 );
					(glist[inx])->state = CACHE_STALE;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
				} else {
					(glist[inx])->msgid = id;
                                	printf( "Searching ldap://%s:%d -b \"%s\" started with id %d\n", (glist[inx])->hn, (glist[inx])->port, (glist[inx])->suffix, id );
					(glist[inx])->state = CACHE_FILL;
				}
			}

			search_fill[inx] = 0;
			tv.tv_usec = 0;

			if ( current_time() > stoptime || current_time() > start_time + (glist[inx])->tlimit ) {
				tv.tv_sec = 0;
			}
			else {
				tv.tv_sec = 1;
			}

			msgtype = ldap_result( (glist[inx])->ld, (glist[inx])->msgid, 1, &tv, &(glist[inx])->res );

			if ( msgtype == 0 ) {
				if ( current_time() > stoptime || current_time() > start_time + (glist[inx])->tlimit ) {
					fprintf(stderr, "Searching ldap://%s:%d  -b \"%s\" timed out with timeout value %d\n", (glist[inx])->hn, (glist[inx])->port, (glist[inx])->suffix, (glist[inx])->tlimit );
					Debug(LDAP_DEBUG_ANY, "Searching ldap://%s:%d  -b \"%s\" timed out\n", (glist[inx])->hn, (glist[inx])->port, (glist[inx])->suffix );
					(glist[inx])->state = CACHE_STALE;
					search_timed_out = 1;
					if(allow_stale_data == 0) {
						search_fill[inx] = 0;
						if((glist[inx])->res) {
							goto res_notnull;
						} else {
							goto res_null;
						}
					}

				}
				else {
					search_fill[inx] = 1;
				}
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
				continue;
			}
			else if (msgtype == -1) {
				fprintf(stderr, "Searching ldap://%s:%d failed\n", (glist[inx])->hn, (glist[inx])->port );
				Debug(LDAP_DEBUG_ANY, "Searching ldap://%s:%d  -b \"%s\" failed\n", (glist[inx])->hn, (glist[inx])->port, (glist[inx])->suffix );
				(glist[inx])->state = CACHE_STALE;
				ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
				continue;
			}

			(glist[inx])->lastmodified = current_time();
			no = 0;

			search_timed_out = 0;
			search_fill[inx] = 0;

res_notnull:
			entry = ldap_first_entry( (glist[inx])->ld, (glist[inx])->res );
			while(entry)
			{
				int size_srch, jj;
				char *tmp_srch;

				tobject = get_obj_from_entry((glist[inx])->ld, entry);
				if (tobject == NULL) {
					msgtype = ldap_msgfree((glist[inx])->res);
					if(search_fill) free(search_fill);
					(glist[inx])->state = CACHE_STALE;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					return -1;
				}
				tsrch_object = strip_comments(tobject);
				srch_object = relable_object(tsrch_object, giisgiven_sfx);
				if(tsrch_object) free(tsrch_object);

				cur_inx = 0;
				cnt = 0;
				dn = get_attribute(srch_object, "dn:", NULL);
				if (!dn) {
					free(srch_object);
					if (tobject) free(tobject);
					entry = ldap_next_entry( (glist[inx])->ld, entry );
					continue;
				}

				/*
				   get the FIRST objectclass to check if the object is 
				   from the GlobusStub of other giis 
				*/
				tmp_srch = strdup(srch_object);
				if (!tmp_srch) {
					fprintf(stderr, "memory allocation error\n");
					Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
					free(dn);
					free(srch_object);
					if (tobject) free(tobject);
					entry = ldap_next_entry( (glist[inx])->ld, entry );
					continue;
				}
				size_srch = strlen(tmp_srch);
				for(jj = 0; jj < size_srch; jj++)
					tmp_srch[jj] = tolower(tmp_srch[jj]);
				tmp_srch[jj] = 0;

				objclass = get_attribute(tmp_srch, "objectclass:", NULL);
				if (!objclass) {
					free(dn);
					free(srch_object);
					free(tmp_srch);
					if (tobject) free(tobject);
					entry = ldap_next_entry( (glist[inx])->ld, entry );
					continue;
				}
				else if(!strcasecmp(objclass, "GlobusStub")) {
					ldap_pvt_thread_mutex_lock( &(gdt->gtrailer_mutex) );
					(void) form_trailer(gdt->gtrailer, gdt->ltrailer, dn);
					ldap_pvt_thread_mutex_unlock( &(gdt->gtrailer_mutex) );
					free(dn);
					free(srch_object);
					free(tmp_srch);
					if (tobject) free(tobject);
					if (objclass) free(objclass);
					entry = ldap_next_entry( (glist[inx])->ld, entry );
					continue;
				}
				if(objclass) free(objclass);
				if(tmp_srch) free(tmp_srch);

				e = str2entry( srch_object );

				cdataobj = (DataObj *) calloc(1, sizeof(DataObj));
				if(!cdataobj) {
					free(dn);
					if (tobject) free(tobject);
					if (srch_object) free(srch_object);
					if(search_fill) free(search_fill);
					if((glist[inx])->res) msgtype = ldap_msgfree((glist[inx])->res);
					(glist[inx])->state = CACHE_STALE;
					if(e) entry_free(e);
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					return -1;
				}
				cdataobj->e = e;
				cdataobj->next = NULL;

				if(!sdataobj) {
					sdataobj = cdataobj;
					edataobj = cdataobj;
				}
				else {
					edataobj->next = cdataobj;
					edataobj = cdataobj;
				}

				if (dispatch_obj(dn, nbase, scope) != 1){
					free(dn);
					free(srch_object);
					if (tobject) free(tobject);
					entry = ldap_next_entry( (glist[inx])->ld, entry );
					continue;
				}
				if(dn) free(dn);

				/* check time limit */
				if ( current_time() > stoptime ) {
					send_ldap_result( conn, op, LDAP_TIMELIMIT_EXCEEDED,
    					NULL, NULL, NULL, NULL );
					free(srch_object);
					if(search_fill) free(search_fill);
					if (tobject) free(tobject);
					if((glist[inx])->res) msgtype = ldap_msgfree((glist[inx])->res);
					if(is_old(glist[inx]))
						(glist[inx])->state = CACHE_STALE;
					else
						(glist[inx])->state = CACHE_READY;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					return( 0 );
				}

				/* check time limit for the entry */
				/*
				if ( current_time() > (glist[inx])->stoptime ) {
					free(srch_object);
					if (tobject) free(tobject);
					break;
				}
				*/


				if ( e && test_filter( be, conn, op, e, filter ) == LDAP_COMPARE_TRUE ) {
					/* check size limit */
					if ( --slimit == -1 ) {
						send_ldap_result( conn, op, LDAP_SIZELIMIT_EXCEEDED,
				    		NULL, NULL, NULL, NULL );
						if (tobject) free(tobject);
						if (srch_object) free(srch_object);
						if(search_fill) free(search_fill);
						if((glist[inx])->res) msgtype = ldap_msgfree((glist[inx])->res);
						if(is_old(glist[inx]))
							(glist[inx])->state = CACHE_STALE;
						else
							(glist[inx])->state = CACHE_READY;
						ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
						return( 0 );
					}

					/* check size limit for the entry */
					if ( --(glist[inx])->slimit == -1 ) {
						free(srch_object);
						if (tobject) free(tobject);
						break;
					}

					send_search_entry( be, conn, op, e, attrs, attrsonly, NULL );
				}

				cnt++;

				if (tobject) free(tobject);
				if (srch_object) free(srch_object);

				entry = ldap_next_entry( (glist[inx])->ld, entry );
			}
			if((glist[inx])->res)
				msgtype = ldap_msgfree((glist[inx])->res);

			jj = (glist[inx])->current;
			jj = (jj + 1) % (glist[inx])->mod;
			if((glist[inx])->dataobj[jj]) {
				cdataobj = (glist[inx])->dataobj[jj];
				ndataobj = cdataobj;
				while(ndataobj) {
					ndataobj = cdataobj->next;
					entry_free(cdataobj->e);
					free(cdataobj);
					cdataobj = ndataobj;
				}
			}
			(glist[inx])->dataobj[jj] = sdataobj;
			(glist[inx])->current = jj;
			sdataobj = NULL;
			edataobj = NULL;
			cdataobj = NULL;
			ndataobj = NULL;

res_null:
			if((glist[inx])->ld) {
				ldap_flush_cache((glist[inx])->ld);
				ub = ldap_unbind((glist[inx])->ld);
				if (ub != 0) {
					fprintf(stderr, "unbind failure with unbind return value %d\n", ub);
					Debug( LDAP_DEBUG_ANY, "unbind failure with unbind return value %d\n", ub, 0, 0 );
					if((glist[inx])->ld) free((glist[inx])->ld);
					(glist[inx])->ld = NULL;
					(glist[inx])->state = CACHE_STALE;
					ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
					continue;
				}
			}
			(glist[inx])->ld = NULL;
			if(search_timed_out)
				(glist[inx])->state = CACHE_STALE;
			else
				(glist[inx])->state = CACHE_READY;

			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);

		}
	}

	current = *gdt->gtrailer;
	while ( current ) {

		tobject = current->data;
		if (tobject == NULL) {
			if(search_fill) free(search_fill);
			return -1;
		}
		srch_object = strip_comments(tobject);
		cur_inx = 0;
		cnt = 0;
		dn = get_attribute(srch_object, "dn:", NULL);
		if (!dn) {
			free(srch_object);
			current = current->next;
			continue;
		}
		if (dispatch_obj(dn, nbase, scope) != 1){
			free(dn);
			free(srch_object);
			current = current->next;
			continue;
		}
		free (dn);

		/* check time limit */
		if ( current_time() > stoptime ) {
			send_ldap_result( conn, op, LDAP_TIMELIMIT_EXCEEDED,
    			NULL, NULL, NULL, NULL );
			free(srch_object);
			if(search_fill) free(search_fill);
			return( 0 );
		}

		e = str2entry( srch_object );

		if ( e && test_filter( be, conn, op, e, filter ) == LDAP_COMPARE_TRUE ) {
			/* check size limit */
			if ( --slimit == -1 ) {
				send_ldap_result( conn, op, LDAP_SIZELIMIT_EXCEEDED,
			    		NULL, NULL, NULL, NULL );
				if (srch_object) free(srch_object);
				if (e) entry_free( e );
				if(search_fill) free(search_fill);
				return( 0 );
			}

			send_search_entry( be, conn, op, e, attrs, attrsonly, NULL );
		}

		if (e) entry_free( e );
		cnt++;

		if (srch_object) free(srch_object);
		current = current->next;
	}

done:
	send_ldap_result( conn, op, err, NULL, NULL, NULL, NULL );

	Debug( LDAP_DEBUG_ANY, "SEARCH SUCCEEDED\n", 0, 0, 0 );

	if(search_fill) free(search_fill);

	return( 0 );
}


int
get_cached_data(
	DataObj		*cachedata,
	int		*registrant_slimit, 
	int		*purged, 
	char		*sfx,
	int		stoptime,
	Backend		*be,
	Connection	*conn,
	Operation	*op,
	const char	*nbase,
	int		scope,
	int		*slimit,
	Filter		*filter,
	char		**attrs,
	int		attrsonly
	)
{
	char 		*dn;
	DataObj		*cdataobj;

	cdataobj = cachedata;
	while (cdataobj) {
		if (*purged) break;
		if (dispatch_obj(cdataobj->e->e_ndn, nbase, scope) != 1){
			cdataobj = cdataobj->next;
			continue;
		}

		/* check time limit */
		if ( current_time() > stoptime ) {
			send_ldap_result( conn, op, LDAP_TIMELIMIT_EXCEEDED, NULL, NULL, NULL, NULL );
			return( 0 );
		}

		if (*purged) break;
		if ( cdataobj->e && test_filter( be, conn, op, cdataobj->e, filter ) == LDAP_COMPARE_TRUE ) {
			/* check size limit */
			if ( --(*slimit) == -1 ) {
				send_ldap_result( conn, op, LDAP_SIZELIMIT_EXCEEDED,
			    		NULL, NULL, NULL, NULL );
				return( 0 );
			}

			/* check size limit for the entry */
			if (*purged) break;
			if ( --(*registrant_slimit) == -1 ) {
				cdataobj = cdataobj->next;
				break;
			}

			if (*purged) break;
			send_search_entry( be, conn, op, cdataobj->e, attrs, attrsonly, NULL );
		}

		if (*purged) break;
		cdataobj = cdataobj->next;
	}

	return 0;
}


int dispatch_obj(char *dn, char *base, int scope)
{

	char *cdn, *cbase, *res, tmpdn[MAX_DN_LENGTH], *strinx;
	int  lcdn, lbase, i, result;

	if ((cdn = canonicalize_dn(dn)) == NULL)
		return 0;
	if ((cbase = canonicalize_dn(base)) == NULL) {
		free (cdn);
		return 0;
	}

	/* base == dn */
	if (!strcasecmp(cdn, cbase)) {
		if (scope == 1)
			result = 0;
		else
			result = 1;
	}

	/* base is an ancestor of dn */
	else if ((res = strstr(cdn, cbase)) != NULL && !strcasecmp(res, cbase)) {

		lcdn = strlen(cdn);
		lbase = strlen(res);

		switch (scope) {
		case 0:
			result = 0;
			break;
		case 1:
			result = 1;
			for (i=0; i<lcdn - lbase - 1; i++)
				if (cdn[i] == ',') {
					/* base is not direct parent of dn */
					result = 0;
					break;
				}
			break;
		case 2:
			result = 1;
			break;
		default:
			fprintf(stderr, "invalid scope: %d\n", scope);
			Debug( LDAP_DEBUG_ANY, "invalid scope: %d\n", scope, 0, 0 );
			result = -1;
			break;
		}
	}
	/* dn is an ancestor of base or dn & base are disjoint */
	else
		result = 0;

	free(cdn);
	free(cbase);

	return result;
}


int dispatch_active_obj(char *dn, char *base, int scope, char *validto)
{

	char *cdn, *cbase, *res, tmpdn[MAX_DN_LENGTH], *strinx;
	int  lcdn, lbase, i, result;

	if (validto != NULL && cmp_gentime(validto) > 0) {
			return 0;
	}

	if ((cdn = canonicalize_dn(dn)) == NULL)
		return 0;
	if ((cbase = canonicalize_dn(base)) == NULL) {
		free (cdn);
		return 0;
	}

	/* base == dn */
	if (!strcasecmp(cdn, cbase)) {
		result = 1;
	}

	/* check if dn is an ancestor of base */
	else if ((res = strstr(cbase, cdn)) != NULL && !strcasecmp(res, cdn)) {
		result = 1;
	}

	/* check if base is an ancestor of dn */
	else if ((res = strstr(cdn, cbase)) != NULL && !strcasecmp(res, cbase)) {

		lcdn = strlen(cdn);
		lbase = strlen(cbase);

		switch (scope) {
		case 0:
			result = 0;
			break;
		case 1:
			result = 1;
			for (i=0; i<lcdn - lbase - 1; i++)
				if (cdn[i] == ',') {
					/* base is not direct parent of dn */
					result = 0;
					break;
				}
			break;
		case 2:
			result = 1;
			break;
		default:
			fprintf(stderr, "invalid scope: %d\n", scope);
			Debug( LDAP_DEBUG_ANY, "invalid scope: %d\n", scope, 0, 0 );
			result = -1;
			break;
		}
	}
	/* base and dn are disjoint */
	else
		result = 0;

	free(cdn);
	free(cbase);

	return result;
}


int is_old(ActiveObj *current)
{

	if (current->cachetime <= 0)
		return 1;

	if (current_time() - current->lastmodified > current->cachetime)
		return 1;
	else
		return 0;
}


char * canonicalize_dn(char *dn)
{

	int i, no, size, cnt, inx;
	char *tdn, *res, *spinx, *nlinx;

	if (!dn) return NULL;

	tdn = (char *) strdup(dn);
	if (!tdn) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return NULL;
	}

	size = strlen(tdn);
	for (i=0; i<size; i++)
		tdn[i] = toupper(tdn[i]);

	spinx = strchr(tdn, ',');
	if (!spinx) {
		no = 0;
		while (no < size)
			if (tdn[no] == ' ' || tdn[no] == '\t' || tdn[no] == '\"')
				no++;
			else
				break;
		if (no >= size) {
			free(tdn);
			return NULL;
		}

		if ((res = (char *) strdup(tdn+no)) == NULL) {
			fprintf(stderr, "memory allocation failure\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			free(tdn);
			return NULL;
		}

		inx = strlen(res);
		while(inx > 0)
			if (res[inx-1] == ' ' || res[inx-1] == '\t' || res[inx-1] == '\"')
				res[--inx] = 0;
			else
				break;

		if (inx) {
			free(tdn);
			return res;
		}
		else {
			free(res);
			free(tdn);
			return NULL;
		}
	}

	if ( (res = (char *) calloc(size+1, sizeof(char))) == NULL ) {
		fprintf(stderr, "memory allocation failure\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		free(tdn);
		return NULL;
	}

	no = 0;
	cnt = 0;

	while ( spinx ) {
		while (no < size)
			if (tdn[no] == ' ' || tdn[no] == '\t' || tdn[no] == '\"')
				no++;
			else
				break;

		for (i = no; i <= spinx - tdn; i++)
			res[cnt++] = tdn[i];

		while (cnt > 0)
			if (res[cnt-1] == ' ' || res[cnt-1] == '\t' || res[cnt-1] == '\"')
				cnt--;
			else
				break;

		no = spinx - tdn + 1;
		spinx = strchr(tdn+no, ',');
	}

	while (no < size)
		if (tdn[no] == ' ' || tdn[no] == '\t' || tdn[no] == '\"')
			no++;
		else
			break;

	for (i = no; i < size; i++)
		res[cnt++] = tdn[i];

	while (cnt > 0)
		if (res[cnt-1] == ' ' || res[cnt-1] == '\t' || res[cnt-1] == '\"')
			cnt--;
		else
			break;
	res[cnt] = 0;

	free(tdn);
	return res;
}


char *
getdataent(char *data, int *cur_inx)
{
	char *res = NULL;
	static ActiveObj *current;
	int no, disp, size, tmp_inx;
	char *inx;

	if (!data)
		return NULL;

	if ((size = strlen(data)) <= 0)
		return NULL;

	if(*cur_inx >= size) 
		return NULL;

	/* get rid of initial blanks */
	if (*(data+*cur_inx) == ' ' || 
	    *(data+*cur_inx) == '\t' ||
	    *(data+*cur_inx) == '\n') 
		(*cur_inx)++;

	if((inx = strstr(data + *cur_inx, "\n\n")) != NULL) {
		disp = (int) (inx - data) - *cur_inx;
		if ((res = (char *) calloc(disp + 1, sizeof(char))) == NULL) {
			fprintf(stderr, "memory allocation failure\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			return NULL;
		}
		for(no=0; no<disp; no++) {
			res[no] = data[*cur_inx + no];
		}
		res[no] = 0;
		*cur_inx = *cur_inx + disp + 2;
		while(*cur_inx < size && data[*cur_inx] == '\n')
				(*cur_inx)++;
		return res;
	}
	else {
		disp = size - *cur_inx;
		if ((res = (char *) calloc(disp + 1, sizeof(char))) == NULL) {
			fprintf(stderr, "memory allocation failure\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			return NULL;
		}
		for(no=0; no<disp; no++) {
			res[no] = data[*cur_inx + no];
		}
		res[no] = 0;
		*cur_inx = *cur_inx + disp + 1;
		tmp_inx = strlen(res) - 1;
		if(tmp_inx > 0 && res[tmp_inx] == '\n')
			res[tmp_inx--] = 0;
		return res;
	}
}


void
print_giis_suffixes(
    FILE        *fp,
    Backend     *be
)
{
	int     i;

	for ( i = 0; be->be_suffix[i] != NULL; i++ ) {
		fprintf( fp, "suffix: %s\n", be->be_suffix[i] );
	}
}


char *
get_obj_from_entry(LDAP *ld, LDAPMessage *entry) {
	BerElement *berptr;
	struct berval **bv;
	char *attr, *dn;
	int inx, count, no;
	char *obj = NULL;

	no = 0;
	dn = ldap_get_dn(ld, entry);
	if (!dn) {
		fprintf(stderr, "dn not found\n");
		Debug( LDAP_DEBUG_ANY, "dn not found\n", 0, 0, 0 );
		return NULL;
	}
	else {
		if(str_merge("dn: ", &obj, &no)==-1) {
			if(obj) free(obj);
			if(dn) free(dn);
			return NULL;
		}
		if(str_merge(dn, &obj, &no)==-1) {
			if(obj) free(obj);
			if(dn) free(dn);
			return NULL;
		}
		if(str_merge("\n", &obj, &no)==-1) {
			if(obj) free(obj);
			if(dn) free(dn);
			return NULL;
		}
	}
	if(dn) free(dn);
	for (attr = ldap_first_attribute(ld, entry, &berptr); attr != NULL; attr = ldap_next_attribute(ld, entry, berptr)) {
		bv = ldap_get_values_len (ld, entry, attr);
		count = ldap_count_values_len (bv);
		for (inx = 0; inx < count; inx++) {
			if(str_merge(attr, &obj, &no)==-1) {
				if(obj) free(obj);
				if(attr) free(attr);
				if (berptr) ber_free(berptr, 0);
				return NULL;
			}
			if(str_merge(": ", &obj, &no)==-1) {
				if(obj) free(obj);
				if(attr) free(attr);
				if (berptr) ber_free(berptr, 0);
				return NULL;
			}
			if(bv[inx]->bv_val && str_merge(bv[inx]->bv_val, &obj, &no)==-1) {
				if(obj) free(obj);
				if(attr) free(attr);
				if (berptr) ber_free(berptr, 0);
				return NULL;
			}
			if(str_merge("\n", &obj, &no)==-1) {
				if(obj) free(obj);
				if(attr) free(attr);
				if (berptr) ber_free(berptr, 0);
				return NULL;
			}
		}
		if (bv) ldap_value_free_len(bv);
		if(attr) free(attr);
	}
	if(str_merge("\n", &obj, &no)==-1) {
		if(obj) free(obj);
		if (berptr) ber_free(berptr, 0);
		return NULL;
	}
	if (berptr) ber_free(berptr, 0);
	return obj;
}


int
str_merge(char *str, char **entry, int *inx)
{
	int len, max = BUFF_SIZE;

	if (!str || !inx) {
		return -1;
	}

	if (*entry == NULL) {
		if (*inx != 0) {
			fprintf(stderr, "invalid index to str_merge\n");
			Debug( LDAP_DEBUG_ANY, "invalid index to str_merge\n", 0, 0, 0 );
			return -1;
		}
		if ( (*entry = (char *) calloc( max, sizeof(char) )) == NULL) {
			fprintf(stderr, "memory allocation failed\n");
			Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
			return -1;
		}
		(void) memset(*entry, 0, max);
	}

	len = strlen( str );
	while ( *inx + len + 1 > max ) { 
		max += BUFF_SIZE; 
	}
	*entry = (char *) realloc( *entry, max );
	if (!*entry) {
		fprintf(stderr, "memory allocation failed\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		return -1;
	}

	strcpy( *entry + *inx, str );
	*inx += len;

	if ((*entry)[0]) {
		return 1;
	}
	else {
		free(*entry);
		return 0;
	}
}


int no_fetches(ActiveObj **glist, int total_inx, int *search_fill)
{

	int inx, cnt=0;

	for (inx=0; inx<total_inx; inx++) {
		ldap_pvt_thread_mutex_lock(&(glist[inx])->active_obj_mutex);
		if (glist[inx]->purged == 0 && search_fill[inx] == 1 ) {
			cnt++;
		}
		ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
	}
	return cnt;
}


int next_inx(ActiveObj **glist, int total_inx, int *search_fill, int current)
{
	int inx, start, res = -1;

	if (current < 0 || current >= total_inx)
		return -1;

	if (current == total_inx - 1) {
		start = 0;
	} else {
		start = current + 1;
	}

	for (inx=start; inx<total_inx; inx++) {
		ldap_pvt_thread_mutex_lock(&(glist[inx])->active_obj_mutex);
		if (glist[inx]->purged == 0 && search_fill[inx] == 1) {
			res = inx;
			ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
			break;
		}
		ldap_pvt_thread_mutex_unlock(&(glist[inx])->active_obj_mutex);
	}
	return res;
}


char * gen_reg_obj( ActiveObj *glist )
{
	int no, inx;
	char *buf, tmp[BUFF_SIZE], *stts = NULL;
	static char *sbind_m[] = { "AUTHC-ONLY", "AUTHC-FIRST", "ANONYM-ONLY", "UNKNOWN-BINDING-METHOD" };

	no = 0;
	buf = NULL;

	if(str_merge("dn: ", &buf, &no)==-1) {
		return NULL;
	}
	if(str_merge(glist->dn, &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge("\nobjectClass: Mds\nobjectClass: MdsVoOp\nobjectClass: MdsService\nobjectClass: MdsServiceLdap\nMds-Service-type: ldap\nMds-Service-hn: ", &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge(glist->hn, &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge("\nMds-Service-port: ", &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	sprintf(tmp, "%d", glist->port);
	if(str_merge(tmp, &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge("\nMds-Service-Ldap-suffix: ", &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge(glist->suffix, &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge("\nMds-Service-Ldap-sizelimit: ", &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	sprintf(tmp, "%d", glist->sizelimit);
	if(str_merge(tmp, &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge("\nMds-Service-Ldap-timeout: ", &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	sprintf(tmp, "%d", glist->timelimit);
	if(str_merge(tmp, &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge("\nMds-Service-Ldap-cachettl: ", &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	sprintf(tmp, "%d", glist->cachetime);
	if(str_merge(tmp, &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if(str_merge("\nMds-Bind-Method-servers: ", &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if ( glist->sbind_method > ANONYM_ONLY || glist->sbind_method < AUTHC_ONLY )
		glist->sbind_method = ANONYM_ONLY;
	if(str_merge(sbind_m[glist->sbind_method], &buf, &no)==-1) {
		if (buf) free(buf);
		return NULL;
	}
	if ( cmp_gentime(glist->keepto) > 0 )
		stts = (char *) strdup("PURGED");
	else if ( cmp_gentime(glist->validto) > 0 )
		stts = (char *) strdup("INVALID");
	else 
		stts = (char *) strdup("VALID");
	if (stts == NULL) {
		fprintf(stderr, "memory allocation error\n");
		Debug( LDAP_DEBUG_ANY, "memory allocation error\n", 0, 0, 0 );
		if (buf) free(buf);
		return NULL;
	}

	if(str_merge("\nMds-Reg-status: ", &buf, &no)==-1) {
		if (buf) free(buf);
		if (stts) free(stts);
		return NULL;
	}
	if(str_merge(stts, &buf, &no)==-1) {
		if (buf) free(buf);
		if (stts) free(stts);
		return NULL;
	}
	if(str_merge("\n\n", &buf, &no)==-1) {
		if (buf) free(buf);
		if (stts) free(stts);
		return NULL;
	}
	if (stts) free(stts);

	return buf;
}

